.area _DATA
.area _CODE


.globl _stage_1
.globl _stage_2
.globl _stage_3
.globl _stage_4
.globl _stage_5

.include "cpctelera.h.s"
.include "player.h.s"
.include "villain.h.s"
.include "map.h.s"

;;
;; PRIVATE DATA
;;
.macro defineBullet name
	name'_data:
	   name'_x: .db #1
	   name'_y: .db #32
	   name'_w: .db #4
	   name'_h: .db #2
	   name'_on: .db #0
	   name'_first: .db #0
	   name'_direction: .db #0
	   name'_finish: .db #0
	   name'_check: .db #1
.endm
bullet_type: .db #0
;bullet_data:
;	bullet_x: .db #1
;	bullet_y: .db #32
;	bullet_w: .db #4
;	bullet_h: .db #2
;	bullet_on: .db #0
;	bullet_first: .db #0


.equ bullet_x, 0
.equ bullet_y, 1
.equ bullet_w, 2
.equ bullet_h, 3
.equ bullet_on, 4
.equ bullet_first, 5
.equ bullet_direction, 6
.equ bullet_finish, 7


defineBullet playerB
defineBullet villainB
defineBullet villainB2
defineBullet villainB3
;;
;; Public FUNCIONS
;;



bullet_draw::
	ld a, #0x4F ;;para dibujar en color rojo, sirve para comprobar si debo borrar o dibujar el sprite
	call drawBullet 

ret

bullet_erase::
	ld a, #0x00 ;;para dibujar en color del fondo 
	call drawBullet 
	
ret
bullet_update::
	ld a,bullet_on(ix)
	cp #0
	jr nz, dibuja
	ret
	dibuja:
	ld a,bullet_on(ix)
	cp #2
	call z, moveBulletLeft
	ld a,bullet_on(ix)
	cp #1
	call z,moveBulletRight
ret

bulletPlayer_getPtrIX::
	ld a,#0
	ld (bullet_type),a
	ld IX,  #playerB_data ;;Return bullet_x memory position
ret
bulletVillain_getPtrIX::
	ld a,#1
	ld (bullet_type),a
	ld IX,  #villainB_data ;;Return bullet_x memory position
ret
bulletVillain2_getPtrIX::
	ld a,#2
	ld (bullet_type),a
	ld IX,  #villainB2_data ;;Return bullet_x memory position
ret		
bulletVillain3_getPtrIX::
	ld a,#3
	ld (bullet_type),a
	ld IX,  #villainB3_data ;;Return bullet_x memory position
ret		
shoot::
	ld a,bullet_on(ix)		;;; comprobamos el estado de la bala
	cp #0						;; podria darse el caso de que ya se ha pulsado p previamente por lo que debemos comprobar si la bala esta activa (bullet on!=0)
	jr z, continuar_disparo1		;; si no es 0 (esta activa) lo dejamos como estaba 
	ret
	continuar_disparo1:			;; si es 0 continua la bala (a bala no activa)

	push ix
	ld a,(bullet_type)
	cp #0
	jr z,ply 
	cp #1
	jr z,vill1
	cp #2
	jr z,vill2
	;;vill
	call villain4_getPtrIX
	jr seguir
	vill2:
	call villain3_getPtrIX
	jr seguir
	vill1:
	call villain1_getPtrIX
	jr seguir
	ply:
	call player_getPtrIX
	seguir:
	;;hl ->player_x
	ld b, 0(IX)		;; b = player_x			
	ld c, 1(IX)		;; c = player_y
	ld d, 2(IX)		;; d = player_w	
	ld e, 3(IX)		;; e = player_h	
	ld h, 4(IX) 		;; i = player_view		
	ld a, 9(IX)		;; player_shot
	cp #0
	jr nz, dispara 				;; comprobamos si el jugador a pulsado la p
	pop ix
	ld a,#0
	ld bullet_first(ix),a 
	ld a,#0x0000
	ld bullet_x(ix),a 
	ld bullet_y(ix),a 
	ret
	dispara:
	pop ix					;;  se ha pulsado la p 
	ld a,bullet_on(ix)
	cp #0
	jr z, continuar_disparo2	;;volvemos a comprobar que la bala este desactivada
	ret
	continuar_disparo2:
	ld a,c 
	add #4
	ld bullet_y(ix),a 	;; c== la bala sale a la altura de la cabeza del personaje

	ld a,h				;; i== disparar a izq o dcha

	cp #0
	jr nz,mira_izq
	
	mira_dcha:
		ld a, #0
		ld bullet_direction(ix), a
		ld a, b
		cp #71
		jr z,fin_shoot
		add d
		inc a
		ld bullet_x(ix),a
		ld a,#1
		jr dibujar
	mira_izq:
		ld a, #1
		ld bullet_direction(ix), a
		ld a, b
		cp #4
		jp m,fin_shoot
		sub #4
		ld bullet_x(ix),a
		ld a,#2
	dibujar:
		ld bullet_on(ix),a
		ld a,#1
		ld bullet_first(ix),a

		fin_shoot:

ret
;;
;; Private FUNCIONS
;;


moveBulletLeft:
	ld a, bullet_x(ix)
	cp #0
	jr z, not_move_left
	jp m, not_move_left
	cp #1
	jr nz, moveL
	push af
	ld a,#0
	ld bullet_first(ix),a
	ld a,#1
	ld bullet_finish(ix),a
	pop af
	moveL:
	dec a
	ld bullet_x(ix), a

	ret
	
	not_move_left:
	ld a,#0
	ld bullet_on(ix),a
	ld a,#1
	ld bullet_finish(ix),a
	
	;call bullet_erase

ret

moveBulletRight:

	ld a, bullet_x(ix)
	cp #80-4
	jr z, not_move_right
	cp #80-5
	jr nz, moveR
	jp m,moveR
	push af
	ld a,#0
	ld bullet_first(ix),a
	ld a,#1
	ld bullet_finish(ix),a
	pop af
	moveR:
	inc a
	ld bullet_x(ix), a

	ret
	
	not_move_right:
	ld a,#0
	ld bullet_on(ix),a
	ld a,#1
	ld bullet_finish(ix),a

	;call bullet_erase

ret



drawBullet:
	push af ;; Guardar a en pila
	ld a, bullet_finish(ix)
	cp #1
	jr z, eraseBullet

	ld a,bullet_first(ix)
	cp #0
	jr nz,drawB
	pop af
	ret
	drawB:
	;;CAlcular Screen position
	call map_getVideoPtr
	ex de, hl
	ld a,  bullet_x(ix)		;;No se puede pasar player_x a C inmediatamente
	ld c, a
	ld a,  bullet_y(ix)		;;No se puede pasar player_y a B inmediatamente
	ld b, a
	call cpct_getScreenPtr_asm	;; Llamar a la funcion

	ld bc, #0x0204	
	;;Draw box
	ex de, HL	;;Intercambiar posiciones de DE y HL

	pop af
	cp #0
	jr z, eraseBullet
	;
	
	
	call cpct_drawSolidBox_asm



	ret

	eraseBullet:
	pop af
	
	ld a, bullet_x(ix)
	ld b, a
	ld a, bullet_direction(ix)
	cp #0
	jr z, der
	inc b
	jr aqui
	der:
	dec b
	aqui:
	ld a, b
	ld b, #2
	ld c, #0
	bucle:
	inc c
	sub b
	


	jp m, divide_y
	jr z, divide_y

	jr bucle

	divide_y:

	dec c

	ld d, #4
	ld a, bullet_y(ix)

	cp #124

	jp p, asignar
	jr z, asignar

	jr here

	asignar:
	ld b, #31
	ld e, #124
	sub e
	jr bu

	here:
	ld b, #0

	bu:
	inc b
	sub d
	

	jp m, redibuja
	jr z, redibuja

	jr bu

	redibuja:
	dec b
	;;llamar a redibujar mapa

	ld a, bullet_finish(ix)
	cp #1
	jr z, debajo

	call getStage
	cp #1
	jr z, stage_uno
	cp #2
	jr z, stage_dos
	cp #3
	jr z, stage_tres
	cp #4
	jr z, stage_cuatro

	ld hl, #_stage_5
	push hl
	jr saltar

	stage_cuatro:
	ld hl, #_stage_4
	push hl
	jr saltar

	ld hl, #_stage_4
	push hl
	jr saltar

	stage_tres:
	ld hl, #_stage_3
	push hl
	jr saltar

	stage_dos:
	ld hl, #_stage_2
	push hl
	jr saltar

	stage_uno:
	ld hl, #_stage_1
	push hl

	saltar:

	call map_getVideoPtr
	push hl

	ld d, #3
	ld e, #3

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ret 

	debajo:

	push bc

	call getStage
	cp #1
	jr z, stage_uno_1
	cp #2
	jr z, stage_dos_1
	cp #3
	jr z, stage_tres_1
	cp #4
	jr z, stage_cuatro_1

	ld hl, #_stage_5
	push hl
	jr saltar_1

	stage_cuatro_1:
	ld hl, #_stage_4
	push hl
	jr saltar_1

	ld hl, #_stage_4
	push hl
	jr saltar_1

	stage_tres_1:
	ld hl, #_stage_3
	push hl
	jr saltar_1

	stage_dos_1:
	ld hl, #_stage_2
	push hl
	jr saltar_1

	stage_uno_1:
	ld hl, #_stage_1
	push hl

	saltar_1:

	ld hl, #0xC000
	push hl

	ld d, #3
	ld e, #3

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	pop bc

	call getStage
	cp #1
	jr z, stage_uno_2
	cp #2
	jr z, stage_dos_2
	cp #3
	jr z, stage_tres_2
	cp #4
	jr z, stage_cuatro_2

	ld hl, #_stage_5
	push hl
	jr saltar_2

	stage_cuatro_2:
	ld hl, #_stage_4
	push hl
	jr saltar_2

	ld hl, #_stage_4
	push hl
	jr saltar_2

	stage_tres_2:
	ld hl, #_stage_3
	push hl
	jr saltar_2

	stage_dos_2:
	ld hl, #_stage_2
	push hl
	jr saltar_2

	stage_uno_2:
	ld hl, #_stage_1
	push hl

	saltar_2:

	ld hl, #0x8000
	push hl

	ld d, #3
	ld e, #3

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ld a, #0
	ld bullet_finish(ix), a

	ret