.area _DATA
.area _CODE

;;
;; ENEMY DATA
;;

;;"globl" del enemigo
.globl _sprite_villain_orange
.globl _sprite_villain_orange_hit
.globl _stage_5

;;variables del enemigo
enemy_data:
	enemy_x: .db #35
	enemy_y: .db #172
	enemy_w: .db #5
	enemy_h: .db #16
	enemy_direction: .db #0 ;variable que almacena la direccion del movimiento del enemigo
	enemy_jumping: .db #-1
	enemy_hit_x: .db #0 	;variable que compruba si el enemigo es al lado en el eje x
	enemy_jump_fall: .db #0 ;| 0 - no tiene que hacer nada, aun no esta al lado del jugador en el eje x
				;| 1 - el enemigo debe saltar == player_y < enemy_y
				;| 2 - el enemigo debe dejarse caer == player_y > enemy_y	
	enemy_hp: .db #60       ;; Vida del enemigo. Se usa con registro IX, no cambiar posicion 
	enemy_hit_player: .db #0
	enemy_y_before: .db #0
	enemy_pos_jump: .db #0
;tabla de salto que contiene los valores para realizarlo
jumptable_up:
	.db #-10,#-9,#-8,#-8
	.db #-6,#-4,#-3,#-2
	.db #-2,#-1,#-1,#-1
	.db #00,#00,#00,#01
	.db #01,#01,#02
	.db #0x80

jumptable_down:
	.db #02
	.db #03,#04,#06,#08
	.db #08,#09,#10
	.db #0x80

.include "cpctelera.h.s"
.include "player.h.s"
.include "map.h.s"

;;
;; PUBLIC FUNCTIONS
;;


;; funcion publica que llama al dibujado del enemigo
enemy_draw::

	ld a, #0xFF ;;para dibujar en color rojo, sirve para comprobar si debo borrar o dibujar el sprite
	call drawEnemy 

	ret

;;funcion para borrar el enemigo
enemy_erase::

	ld a, #0x00 ;;para dibujar en color del fondo 
	call drawEnemy 

	ret

;;funcion para devolver las variables de enemigo
enemy_getPtrIX::

	ld IX, #enemy_data ;;Return player_x memory position


	ret

;;funcion que controla todo el movimiento de la Intercambiar
enemy_ia::

	ld a, (enemy_jump_fall)
	cp #0
	jr nz, do_action ;si enemy_jump_fall != 0 entonces compruebo la accion a realizar, sino...

		;sigo comprobando hasta que el enemigo este al lado del player en el eje x

		;push ix		;guardo en la pila la posicion del player
		call enemy_movement_x	;llamo al movimiento en el eje x


		;call check_hit

		;pop ix			;saco de la pila la posicion del player
		call enemy_movement_y	;llamo al movimiento en el eje y


		ret

	;el enemigo debe saltar o dejarse caer, compruebo que debe hacer
	do_action:

	cp #1
	jr z, do_jump ;si enemy_jump_fall == 1, entonces debe saltar

		;sino debe dejarse caer
		ld hl, #jumptable_down  ;cargo en HL el primer valor de la tabla
		call enemy_jump
		ret

	do_jump:

		ld hl, #jumptable_up  ;cargo en HL el primer valor de la tabla
		call enemy_jump


	ret


checkEnemyCollision:: 
	  ;;COLLISON X: 
	  ;; if (obs_x+obs_w <= hero_x) no collision -> (obs_x+obs_w-hero_x <= 0) 
	  ld a, (enemy_x)      ;; obs_x 
	  ld c, a         ;; + 
	  ld a, (enemy_w)      ;; obs_w 
	  add c           ;; -  
	  ld b,0(ix)        ;; enemy_x 
	  sub a,b 
	 
	  jr z,no_colission    ;; if (<= 0) 
	  jp m,no_colission    ;; then no_collision 
	 
	  ;; if (hero_x+hero_w <= obs_x) no collision -> (hero_x+hero_w-obs_x <= 0) 
	  ld a,0(ix) 
	  ld d,2(ix) 
	  add a,d 
	  ld c, a 
	  ld a, (enemy_x) 
	  ld b, a 
	  ld a, c 
	  sub b 
	  jr z,no_colission    ;; if (<= 0) 
	  jp m,no_colission    ;; then no_collision 
	   
	  ;COLLISON Y 
	  ;if (hero_y+hero_h <= obs_y) no collision -> (hero_y+hero_h-obs_y <= 0) 
	   
	  ld a, (enemy_y) 
	  ld c, a 
	  ld a,1(ix) 
	  ld d,3(ix) 
	  add a,d 
	  sub c 
	  jr z,no_colission    ;; if (<= 0) 
	  jp m,no_colission    ;; then no_collision 

	    ;if (obs_y+obs_h <= hero_y) no collision -> (obs_y+obs_h- hero_y <= 0) 
	  ld a, (enemy_y)      ;; obs_y 
	  ld c, a         ;; + 
	  ld a, (enemy_h)      ;; obs_w 
	  add c           ;; -  
	  ld d,1(ix) 
	  sub a,d      ;; hero_y 
	  jr z,no_colission    ;; if (<= 0) 
	  jp m,no_colission    ;; then no_collision 
	  ld a,#0 
	  ld 4(ix),a 
	  ld 5(ix),a 
	  ld a,#0x8000
	  ld 0(ix),a 
	  ld 1(ix),a 
	 
	 
	  ld a,#0xFF 
	  ld a,(enemy_direction)
	  cp #0
	  jr z,izquierda
	  ;;derecha
	  ld a, (enemy_x)
	  sub #4
	  ld (enemy_x),a 
	  jr fin_direccion
	  izquierda:
	  ld a,(enemy_x)
	  add #4
	  ld (enemy_x),a 
	  fin_direccion:


	  ld a,8(ix)
	  cp #0
	  jr nz,bala
	  ld a,9(ix)
	  cp #0
	  jr z,no_colission
	  ld a,#0
	  ld 9(ix),a
	  bala:
	  

	  ld a,(enemy_hp)
	  sub #5
	  ld (enemy_hp),a
	  ret 
	 
	  no_colission: 
	    ld a,#00 
	 
	  ret 
	  ;; if (hero_x+hero_w > obs_x) collision 
	  ;; if (obs_x+obs_w > hero_x) collision 
	ret 

enemy_reset::

	ld a, #35
	ld (enemy_x),a

	ld a, #172
	ld (enemy_y),a

	ld a, #60
	ld (enemy_hp),a

	ld a, #0	
	ld (enemy_jump_fall),a	
	ld (enemy_hit_x),a	
	ld (enemy_direction),a
	ld (enemy_pos_jump),a
	ld a, #-1
	ld (enemy_jumping),a
	ret

enemy_checkDirection::
	ld a,(enemy_direction)
	cp #1
	jr nz,not_rot_view3
	call dibujarGiroSprite
	call dibujarGiroSpriteGolpe
	ld a, #0
	ld (enemy_direction), a
	not_rot_view3:

	ret
;;
;; PRIVATE FUNCTIONS
;;


;;funcion para girar el sprite segun la direccion de movimiento del enemigo
dibujarGiroSprite:		
	ld bc, #0x1005		;;guardo en bc el largo y ancho del sprite en hexadecimal
	ld hl, #_sprite_villain_orange
	call cpct_hflipSpriteMaskedM0_asm
ret

;;funcion para girar el sprite segun la direccion de movimiento del enemigo
dibujarGiroSpriteGolpe:		
	ld bc, #0x1005		;;guardo en bc el largo y ancho del sprite en hexadecimal
	ld hl, #_sprite_villain_orange_hit
	call cpct_hflipSpriteMaskedM0_asm
ret

enemy_movement_x:

	;;comprobar si el personaje esta a la izquierda del enemigo
	;;player_x+player_w-enemy_x = 0

	ld a, (enemy_y)

	cp #122

	jr z, comp_x

	jr go_on

	comp_x:

	ld a, (enemy_x)
	cp #57

	jp m, comp_x_1

	jr go_on

	comp_x_1:

	cp #30

	jp p, pa_abajo

	jr go_on

	pa_abajo:
	ld a, #2
	ld (enemy_jump_fall), a
	ld hl, #jumptable_down
	call enemy_jump

	go_on:
	ld a, 0(ix)	;cargo en a player_x
	add 2(ix)	;player_x + player_w
	ld b, a		;guardo el resultado en b
	ld a, (enemy_x)	;cargo en a la posicion del enemigo = enemy_x
	ld c, a		;guardo enemy_x en c
	ld a, b		;obtengo la suma anterior en a
	sub c		;player_x + player_w - enemy_x


	jp m, on_the_left ;si el resultado es negativo, el personaje esta a la izquierda, por tanto me muevo hacia el
	jp z, next_to_player  ;si estoy al lado de el, golpeo

	;;comprobar si el personaje esta a la derecha del enemigo
	;;enemy_x+enemy_w-player_x = 0

	ld a,(enemy_x)  ;cargo en a enemy_x
	ld b, a 	;|
	ld a, (enemy_w) ;|lo paso a b para poder cargar en a enemy_w
	add b 		;enemy_x + enemy_w
	sub 0(ix)	;se lo resto al registro a -> enemy_x + enemy_w - player_x

	jp m, on_the_right ;si el resultado es negativo, el personaje esta a la derecha, por tanto me muevo hacia el
	jp z, next_to_player   ;;si estoy al lado de el, golpe


	on_the_left: ;me muevo hacia el player, situado a mi izquierda hasta su posicion
		ld a, (enemy_x)
		dec a  		;decremento la posicion del enemigo = enemy_x - 1
		ld (enemy_x),a

		ld a, (enemy_direction) ;|guardo enemy_direction y compruebo si estaba moviendose
		cp #1			;|hacia la derecha, en cuyo caso giro el sprite hacia la izquierda
		jr z, giroSprite

		ret

		giroSprite:
		call dibujarGiroSprite
		call dibujarGiroSpriteGolpe
		ld a, #0 	;pongo el enemy_direction a 0 ->se esta moviendo hacia la izquierda
		ld (enemy_direction), a

		ret

	;;comprobar si el personaje esta a la derecha del enemigo
	;;player_x+player_w-enemy_x = 0

	on_the_right:
		ld a, (enemy_x)
		inc a  		;incremento la posicion del enemigo = enemy_x + 1
		ld (enemy_x),a
		
		ld a, (enemy_direction) ;|guardo enemy_direction y compruebo si estaba moviendose
		cp #0		;|hacia la izquierda, en cuyo caso giro el sprite hacia la derecha
		jr z, giroSprite_1

		ret

		giroSprite_1:
		call dibujarGiroSprite
		call dibujarGiroSpriteGolpe
		ld a, #1  	;pongo el enemy_direction a 1 ->se esta moviendo hacia la derecha
		ld (enemy_direction), a
		ret

	;;el enemigo esta al lado del personaje en el eje x, ahora compruebo en y
	next_to_player:
		ld a, #1
		ld (enemy_hit_x), a

	ret


;;comprobar si el enemigo esta a la misma altura que el personaje
enemy_movement_y:

	ld a, (enemy_hit_x) 	;cargo en a -> enemy_hit_x
	cp #1			;le resto uno para comprobar si el enemigo esta al lado del personaje en el eje x	

	jr z, continue 		;si esta al lado, continuo con la comprobacion

	ret

	continue:		;comprobar la posicion del enemigo respecto al player en el eje y
	ld a, (enemy_y)		;|almaceno en a enemy_y 
	sub 1(ix)			;|y le resto player_y

	jp z, same_y
	jp p, player_up		;player_y < enemy_y
	jp m, player_down	;player_y > enemy_y

	player_up: 		;almaceno 1 para indicar que el enemigo debe saltar

		cp #46
		jp p, cont

		ret

		cont:
		ld a, #1
		ld (enemy_jump_fall), a
		ret

	player_down:		;almaceno 2 para indicar que el enemigo debe dejarse caer	

		ld b, #10
		add b
		cp #5
		jp m, debajo
		ret

		debajo:
		ld a, #2
		ld (enemy_jump_fall), a
		ret

	same_y:

		;ld b, #2
		;add b
		;jr z, hitting
		;ret

		;hitting:
		;ld a, #1
		;ld (enemy_hit_player), a

	ret

check_hit:
	ld a, (enemy_hit_x)
	cp #1
	jr z, check_y
	ret

	check_y:
	ld a, (enemy_y)
	ld b, a
	ld a, 1(ix)
	sub b
	cp #2
	jr z, contacto
	ret

	contacto:
	ld a, #1
	ld (enemy_hit_player), a

	ret


enemy_jump:

	ld a, #0
	ld (enemy_jumping), a

	ld a, (enemy_pos_jump) ;cargo en a el indice de la tabla de saltos

	ld c, a		;|
	ld b, #0	;|cargo en bc el indice actual de la tabla

	add hl,bc	;|se lo sumo a HL para obtener el valor de salto actual

	ld a, (hl)		;|
	cp #0x80		;|
	jr z, end_of_jump;|compruebo si se ha llegado al final de la tabla de saltos

	ld b, a			;|
	ld a, (enemy_y)		;|
	ld (enemy_y_before), a
	add b			;|
	ld (enemy_y), a		;|le sumo a enemy_y el valor de salto actual para variar la posicion vertical del enemigo

	ld a, (enemy_pos_jump)	;|
	inc a			;|
	ld (enemy_pos_jump), a	;|incremento en 1 el indice de la tabla para coger el siguiente valor

	ret

	end_of_jump:		;si he terminado de saltar

		ld a, #-1
		ld (enemy_jumping), a	;reinicio el indice de salto a 0
		ld a, #0
		ld (enemy_jump_fall), a	;reinicio el estado del enemigo a 0, para que no haga nada
		ld a, #0
		ld (enemy_pos_jump), a

	ret


;;dibuja al enemigo
drawEnemy:
	;; Guardar a en pila
	push af

	;;Calcular Screen position
	call map_getVideoPtr
	ex de, hl
	ld a,  (enemy_x)		;;No se puede pasar enemy_x a C inmediatamente
	ld c, a
	ld a,  (enemy_y)		;;No se puede pasar enemy_y a B inmediatamente
	ld b, a
	call cpct_getScreenPtr_asm	;; Llamar a la funcion

	;;Dibujar el enemigo o borrarlo dependiendo del valor pasado en el registro a
	ex de, HL
	pop af			;;Intercambiar posiciones de DE y HL
	ld bc, (enemy_w)     	;;10x16 pixeles	
	cp #00			;;compruebo si voy a borrar o dibujar
	jr z, erasePlayer

	ld a, (enemy_hit_x)
	cp #1
	jr z, enemigo_golpea

	ld hl, #_sprite_villain_orange
	call cpct_drawSpriteMasked_asm
	ret

	enemigo_golpea:

	call player_getPtrIX
	ld a, (enemy_y)
	sub 1(ix)
	jr z, quito
	ld a, #0
	ld (enemy_hit_x), a
	ld hl, #_sprite_villain_orange
	call cpct_drawSpriteMasked_asm
	ret

	quito:
	ld hl, #_sprite_villain_orange_hit
	call cpct_drawSpriteMasked_asm
	ld a, #5
	ld b, a
	call player_hit_life
	ld a, #0
	ld (enemy_hit_x), a

	ret

	erasePlayer:

	call enemy_getPtrIX

	ld a, 0(ix)
	ld b, a
	ld a, 4(ix)
	cp #1
	jr z, der
	inc b
	jr aqui
	der:
	dec b
	aqui:
	ld a, b
	ld b, #2
	ld c, #0
	bucle:
	inc c
	sub b
	


	jp m, divide_y
	jr z, divide_y

	jr bucle

	divide_y:

	dec c
	dec c

	ld d, #4
	ld a, 5(ix)
	cp #0
	jp p, salta
	jr z, salta

	ld a, 1(ix)

	jr siguelo

	salta:
	ld a, 10(ix)

	siguelo:
	dec a
	cp #124

	jp p, asignar
	jr z, asignar

	jr here

	asignar:
	ld b, #31
	ld e, #124
	sub e
	jr bu

	here:
	ld b, #0

	bu:
	inc b
	sub d
	

	jp m, redibuja
	jr z, redibuja

	jr bu

	redibuja:
	dec b
	;;llamar a redibujar mapa

	ld hl, #_stage_5
	push hl

	call map_getVideoPtr
	push hl

	ld d, #6
	ld e, #9

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ret