.area _DATA
.area _CODE




;;
;; PRIVATE DATA
;;

hit_data:
	hit_x: .db #1
	hit_y: .db #32
	hit_w: .db #2
	hit_h: .db #4
	hit_cont: .db #0
	hit_first: .db #0
	hit_direction: .db #0
	hit_finish: .db #0
	hit_check: .db #0
	hit_colision: .db #0
;.equ hit_x, 0
;.equ hit_y, 1
;.equ hit_on, 2

.globl _stage_1
.globl _stage_2
.globl _stage_3
.globl _stage_4
.globl _stage_5
.globl _sprite_hit
.include "cpctelera.h.s"
.include "map.h.s"
;;
;; Public FUNCIONS
;;


hit_draw::
	ld a, #0x0F ;;para dibujar en color rojo, sirve para comprobar si debo borrar o dibujar el sprite
	call drawHit 

ret

hit_erase::
	
	ld a, #0x00 ;;para dibujar en color del fondo 
	call drawHit 
	
ret
hit_update::
	ld a,(hit_cont)
	cp #0
	jr z, zero
	cp #2
	jr z, dos
	dec a
	ld (hit_cont),a
	ret
	zero:
	call hit_erase
	ld a,#0
	ld (hit_cont),a
	ld (hit_first),a
	ld a,#1
	ld (hit_finish),a
	dos:
	dec a
	ld (hit_cont),a
	ld a,#1
	ld (hit_finish),a
	
	
ret
hit_getPtrIX::
	ld IX, #hit_x ;;Return bullet_x memory position
ret	
startHit::

	ld a,(hit_cont)			;;; comprobamos el estado del golpeo
	cp #0						;; podria darse el caso de que ya se ha pulsado p previamente por lo que debemos comprobar si el golpeo esta activo (hit on!=0)
	jr z, continuar_golpe1		;; si no es 0 (esta activa) lo dejamos como estaba 
	ret
	continuar_golpe1:			;; si es 0 continua el golpeo (el golpeo no activo)
	

	;;hl ->player_x
	ld b, 0(IX)		;; b = player_x			
	ld c, 1(IX)		;; c = player_y
	ld d, 2(IX)		;; d = player_w	
	ld e, 3(IX)		;; e = player_h	
	ld h, 4(IX) 		;; i = player_view		
	ld a, 10(IX)		;; player_hit
	cp #0
	jr nz, golpea 				;; comprobamos si el jugador a pulsado la p
	ld a,#0
	ld (hit_first),a 
	ld a,(hit_x)
	ld a,#255
	ld (hit_x),a 
	ld a,#200
	ld (hit_y),a 
	
	ret
	golpea:					;;  se ha pulsado la p 
	ld a,(hit_cont)
	cp #0
	jr z, continuar_golpe2	;;volvemos a comprobar que el golpeo este desactivada
	ret
	continuar_golpe2:
	ld a,c 
	add #4
	ld (hit_y),a 	;; c== hit sale a la altura de la cabeza del personaje

	ld a,h				;; i== disparar a izq o dcha

	cp #0
	jr nz,mira_izq
	
	mira_dcha:
		ld a, #0
		ld (hit_direction), a
		ld a, b
		cp #70
		jr z,fin_golpe
		add d
		add #1
		jr dibujar
	mira_izq:
		ld a, #1
		ld (hit_direction), a
		ld a, b
		cp #0
		jr z,fin_golpe
		sub #3
	
	dibujar:
		ld (hit_x),a
		ld a,#10
		ld (hit_cont),a
		ld a,#1
		ld (hit_first),a
	fin_golpe:
	ld a,#1
	ld (hit_colision),a

ret
;;
;; Private FUNCIONS
;;





drawHit:
	push af ;; Guardar a en pila
	ld a, (hit_finish)
	cp #1
	jr z, eraseHit
	ld a,(hit_first)
	cp #0
	jr nz,drawH
	pop af
	ret
	drawH:
	;;CAlcular Screen position
	call map_getVideoPtr
	ex de, hl
	ld a,  (hit_x)		;;No se puede pasar player_x a C inmediatamente
	ld c, a
	ld a,  (hit_y)		;;No se puede pasar player_y a B inmediatamente
	ld b, a
	call cpct_getScreenPtr_asm	;; Llamar a la funcion

	ld bc, #0x0402	
	;;Draw box
	ex de, HL	;;Intercambiar posiciones de DE y HL

	pop af
	cp #0
	jr z, eraseHit
	;
	
	ld hl,#_sprite_hit
	call cpct_drawSpriteMasked_asm



	ret
	eraseHit:
	pop af
	
	ld a, (hit_x)
	ld b, a
	ld a, (hit_direction)
	cp #0
	jr z, der
	inc b
	jr aqui
	der:
	dec b
	aqui:
	ld a, b
	ld b, #2
	ld c, #0
	bucle:
	inc c
	sub b
	


	jp m, divide_y
	jr z, divide_y

	jr bucle

	divide_y:

	dec c

	ld d, #4
	ld a, (hit_y)

	cp #124

	jp p, asignar
	jr z, asignar

	jr here

	asignar:
	ld b, #31
	ld e, #124
	sub e
	jr bu

	here:
	ld b, #0

	bu:
	inc b
	sub d
	

	jp m, redibuja
	jr z, redibuja

	jr bu

	redibuja:
	dec b
	;;llamar a redibujar mapa

	ld a, (hit_finish)
	cp #1
	jr z, debajo

	call getStage
	cp #1
	jr z, stage_uno
	cp #2
	jr z, stage_dos
	cp #3
	jr z, stage_tres
	cp #4
	jr z, stage_cuatro

	ld hl, #_stage_5
	push hl
	jr saltar

	stage_cuatro:
	ld hl, #_stage_4
	push hl
	jr saltar

	ld hl, #_stage_4
	push hl
	jr saltar

	stage_tres:
	ld hl, #_stage_3
	push hl
	jr saltar

	stage_dos:
	ld hl, #_stage_2
	push hl
	jr saltar

	stage_uno:
	ld hl, #_stage_1
	push hl

	saltar:

	call map_getVideoPtr
	push hl

	ld d, #3
	ld e, #3

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ret 

	debajo:

	push bc

	call getStage
	cp #1
	jr z, stage_uno_1
	cp #2
	jr z, stage_dos_1
	cp #3
	jr z, stage_tres_1
	cp #4
	jr z, stage_cuatro_1

	ld hl, #_stage_5
	push hl
	jr saltar_1

	stage_cuatro_1:
	ld hl, #_stage_4
	push hl
	jr saltar_1

	ld hl, #_stage_4
	push hl
	jr saltar_1

	stage_tres_1:
	ld hl, #_stage_3
	push hl
	jr saltar_1

	stage_dos_1:
	ld hl, #_stage_2
	push hl
	jr saltar_1

	stage_uno_1:
	ld hl, #_stage_1
	push hl

	saltar_1:

	ld hl, #0xC000
	push hl

	ld d, #3
	ld e, #3

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	pop bc

	call getStage
	cp #1
	jr z, stage_uno_2
	cp #2
	jr z, stage_dos_2
	cp #3
	jr z, stage_tres_2
	cp #4
	jr z, stage_cuatro_2

	ld hl, #_stage_5
	push hl
	jr saltar_2

	stage_cuatro_2:
	ld hl, #_stage_4
	push hl
	jr saltar_2

	ld hl, #_stage_4
	push hl
	jr saltar_2

	stage_tres_2:
	ld hl, #_stage_3
	push hl
	jr saltar_2

	stage_dos_2:
	ld hl, #_stage_2
	push hl
	jr saltar_2

	stage_uno_2:
	ld hl, #_stage_1
	push hl

	saltar_2:

	ld hl, #0x8000
	push hl

	ld d, #2
	ld e, #2

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ld a, #0
	ld (hit_finish), a

	ret