.area _DATA
.area _CODE

.include "cpctelera.h.s"
.include "player.h.s"
.include "enemy.h.s"
.include "map.h.s"
;;==============================================================
;; PRIVATE DATA
;;==============================================================

hud_hp_y: .db #10	;; Variable que se cambia cada vez que se llama a draw_life, para dibujar la vida del jugador y del enemigo en sitios distintos
hud_game_end: .db #0		;; 0: no acaba el juego, 1: game win, 2: game over
hud_game_win: .dw "GA", "ME", " W", "IN", #0
hud_game_over: .dw "GA", "ME", " O", "VE","R ", #0
hud_reset_text: .dw "PR", "ES", "S ", "R ", " T", "O ", "RE", "SE", "T ", #0
hud_you: .dw "ME", #0
hud_enemy: .dw "IA", #0
hud_drawing_ply: .db #0
hud_drawing_emy: .db #0

;;==============================================================
;; PUBLIC FUNCTIONS
;;==============================================================

hud_draw::
    call player_getPtrIX
    ld a, #0xF0
    call draw_life

    call enemy_getPtrIX
    ld a, 8(IX)
    cp #0
    jr nz, enemy_no_muere

    ld a, #2
    ld (hud_game_end), a

    enemy_no_muere:

    call draw_GameOver

    ld a, (hud_game_end)

    ret

hud_erase::
    call player_getPtrIX
    ld a, #0x00
    call draw_life
ret

hud_reset::

    ;;hud_game_end
    ld a, #0
    ld (hud_game_end),a
    ld a, #10
    ld (hud_hp_y),a

    ret

hud_draw_enemy::

    ld (hud_drawing_emy), a
    call map_getVideoPtr
    ex de, hl            ;; Almacenar la primera posicion de video
    ld c, #1            ;; 
    ld a, (hud_hp_y)
    add #10
    ld b, a
    call cpct_getScreenPtr_asm    ;; Primero se implementa el nombre y posteriormente la barra

    ex de, hl
    ld hl, #hud_enemy
    ld c,#0x0F
    ld b,#00
    call cpct_drawStringM0_asm

    call map_getVideoPtr
    ex de, hl
    ld a, (hud_hp_y)
    add #10
    ld b, a
    ld c, #13
    
    call cpct_getScreenPtr_asm


    ex de, hl
    call enemy_getPtrIX
    ld a, 8(IX)            ;;Comprobar si la vida del personaje es menor de 0
    cp #0                ;;
    jp m, muerto2
    jr z, muerto2
    jr  vivo2
    muerto2:            
    ld 8(ix), #1            ;; Se comprueba de quien es la vida
    ld a, #2
    ld (hud_game_end), a

    ld a, #0
    ld (hud_drawing_emy), a

    vivo2:
    ld c, 8(ix)
    ld b, #5
    ld a, (hud_drawing_emy)
    cp #0
    jr nz, no_borrar2
    ld c, #60            ;; Si estamos en la iteracion de borrado se debe borrar la barra entera para ver la actualizacion
    no_borrar2:
    call cpct_drawSolidBox_asm

    ret
;;==============================================================
;; PRIVATE FUNCTIONS
;;==============================================================


draw_GameOver:
    ;;Calcular Screen position
    ld a, (hud_game_end)
    cp #0
    ret z

    call map_getVideoPtr
    ex de, hl
    ld c, #25
    ld b, #50
    call cpct_getScreenPtr_asm    ;; Llamar a la funcion

    ex de, hl
    ld a, (hud_game_end)
    cp #1
    jr z, game_over
    ld hl, #hud_game_win
    jr dibujar_game
    game_over:
    ld hl, #hud_game_over
    dibujar_game:
    ld c, #0x0F
    ld b, #00

    call cpct_drawStringM0_asm


    call map_getVideoPtr
    ex de, hl
    ld c, #5
    ld b, #100
    call cpct_getScreenPtr_asm    ;; Llamar a la funcion

    ex de, hl
    ld hl, #hud_reset_text
    ld c, #0x0F
    ld b, #00

    call cpct_drawStringM0_asm

    call map_switchBuffers

    call map_getVideoPtr
    ex de, hl
    ld c, #25
    ld b, #50
    call cpct_getScreenPtr_asm    ;; Llamar a la funcion

    ex de, hl
    ld a, (hud_game_end)
    cp #1
    jr z, game_over2
    ld hl, #hud_game_win
    jr dibujar_game2
    game_over2:
    ld hl, #hud_game_over
    dibujar_game2:
    ld c, #0x0F
    ld b, #00

    call cpct_drawStringM0_asm

    call map_getVideoPtr
    ex de, hl
    ld c, #5
    ld b, #100
    call cpct_getScreenPtr_asm    ;; Llamar a la funcion

    ex de, hl
    ld hl, #hud_reset_text
    ld c, #0x0F
    ld b, #00

    call cpct_drawStringM0_asm


    ret

;;==============================================================
;; Pasar por registro IX la vida del enemigo o del jugador
;;==============================================================
draw_life:
    ld (hud_drawing_ply), a

    ld a, (hud_game_end)        ;; Comprobar si el juego ha acabado para dejar de actualizar la vida
    cp #0
    ret nz   
    call map_getVideoPtr
    ex de, hl            ;; Almacenar la primera posicion de video
    ld c, #1            ;; 
    ld a, (hud_hp_y)
    ld b, a
    call cpct_getScreenPtr_asm    ;; Primero se implementa el nombre y posteriormente la barra

    ex de, hl
    ld hl, #hud_you
    ld c,#0x0F
    ld b,#00
    call cpct_drawStringM0_asm

    call map_getVideoPtr
    ex de, hl
    ld a, (hud_hp_y)
    ld b, a
    ld c, #13
    
    call cpct_getScreenPtr_asm


    ex de, hl
    call player_getPtrIX
    ld a, 8(IX)            ;;Comprobar si la vida del personaje es menor de 0
    cp #0                ;;
    jp m, muerto
    jp z, muerto
    jp  vivo
    muerto:            
    ld 8(ix), #1            ;; Se comprueba de quien es la vida
    ld a, #1
    ld (hud_game_end), a

    ld a, #0
    ld (hud_drawing_ply), a

    vivo:
    ld c, 8(ix)
    ld b, #5
    ld a, (hud_drawing_ply)
    cp #0
    jr nz, no_borrar
    ld c, #60            ;; Si estamos en la iteracion de borrado se debe borrar la barra entera para ver la actualizacion
    no_borrar:
    call cpct_drawSolidBox_asm

    ret