.area _DATA
.area _CODE

.include "player.h.s"
.include "enemy.h.s"
.include "stage_1.h.s"
.include "stage_2.h.s"
.include "stage_3.h.s"
.include "stage_4.h.s"
.include "stage_final.h.s"
.include "bullet.h.s"
.include "hit.h.s"
.include "hud.h.s"
.include "menu.h.s"
.include "cpctelera.h.s"
.include "map.h.s"
.include "villain.h.s"
.globl _g_palette
.globl _song_ingame

music_sync: .db #12
hud_vsync: .db #3
main_game_end: .db #0

isr:
    ex af, af'
    exx
    push af
    push bc
    push de
    push hl
    push iy

    ld a, (music_sync)
    dec a
    ld (music_sync), a

    jr nz, return

    call cpct_akp_musicPlay_asm
    ld a, #12
    ld (music_sync), a

    return:

    pop iy
    pop hl
    pop de
    pop bc
    pop af
    exx
    ex af, af'

ret

erase_main:

	call player_erase
	call bulletPlayer_getPtrIX
	call bullet_erase
	call bulletVillain_getPtrIX
	call bullet_erase
	call bulletVillain2_getPtrIX
	call bullet_erase
	call bulletVillain3_getPtrIX
	call bullet_erase
	call hit_erase
	call villain_erase

	ret

draw_update_main:

	call bulletPlayer_getPtrIX
	call bullet_update
	call bulletVillain_getPtrIX
	call bullet_update
	call bulletVillain2_getPtrIX
	call bullet_update
	call bulletVillain3_getPtrIX
	call bullet_update
	call hit_update
	call bulletPlayer_getPtrIX
	call shoot
	call bulletVillain_getPtrIX
	call shoot
	call bulletVillain2_getPtrIX
	call shoot
	call bulletVillain3_getPtrIX
	call shoot
	call player_getPtrIX
	call startHit

	call playerCollision

	call bulletPlayer_getPtrIX
	call bullet_draw
	call bulletVillain_getPtrIX
	call bullet_draw
	call bulletVillain2_getPtrIX
	call bullet_draw
	call bulletVillain3_getPtrIX
	call bullet_draw
	call villain_draw
	call hit_draw
	call player_draw

	ret

hud_vsync_main:

	call hud_erase
    call hud_draw
    ld (main_game_end), a
	call cpct_waitVSYNC_asm
	call map_switchBuffers

	ret
playerCollision:
	call bulletVillain_getPtrIX
	call player_getPtrIY
	call checkPlayerCollision

	call bulletVillain2_getPtrIX
	call player_getPtrIY
	call checkPlayerCollision

	call bulletVillain3_getPtrIX
	call player_getPtrIY
	call checkPlayerCollision

	call villain0_getPtrIX
	call player_getPtrIY
	call checkPlayerCollision

	call villain1_getPtrIX
	call player_getPtrIY
	call checkPlayerCollision

	call villain4_getPtrIX
	call player_getPtrIY
	call checkPlayerCollision
ret
show_stage_info:
	call drawStage
	call map_switchBuffers
	ld a,#0
	stage1:
	halt
	inc a 
	cp #255
	jp nz,stage1
ret
show_stage_info2:
	call drawStage
	call map_switchBuffers
	ld a,#0
	stage3:
	halt
	inc a 
	cp #255
	jp nz,stage3
	ld a,#0
	stage03:
	halt
	inc a 
	cp #255
	jp nz,stage03

	
ret
initialize:

	call cpct_disableFirmware_asm	;;
	ld c , #0			;; Change video mode 
	call cpct_setVideoMode_asm	;;

	ld hl, #_g_palette		;;
	ld de, #16			;; Set base colors
	call cpct_setPalette_asm	;; 

   	ld hl, #0x1410
    call cpct_setPALColour_asm
        
	ret

_main::
	ld sp, #0x8000

	call initialize
	menu:
	call menubackgroundpdraw
	menu1:
	call map_switchBuffers
	call menu_draw
	call checkKey
	call startMenu

	ld b,a 
	cp #0
	jr z,menu1
	;;---Aqui pasamos a dibujar el cartel de nivel
	call map_1_draw
	ld a,#1
	call setStage
	call show_stage_info

	ld hl, #0x0E0A
    call cpct_setPALColour_asm

	;; Una vez mostrado pasamos a inicializar todas las entidades antes del bucle level_loop
	call initialize_map1
	call map_1_draw
	call player_disableShot
	ld de, #_song_ingame
   	call cpct_akp_musicInit_asm
   	ld hl, #isr
   	call cpct_setInterruptHandler_asm
	
	level1_loop:

	call erase_main

	call floor_stage_1_check_collision
	call player_update
	call checkCollision_ia_stage_1

	call draw_update_main
	

	call hud_vsync_main
	ld a, (main_game_end)
	cp #0
	jp nz, finish

	call checkGoNextLevel
	ld a, b
    	cp #1

    	jr z, redrawmap_2
	jp level1_loop
;;inicializar nivel 2
	redrawmap_2:

	call map_2_draw
	ld a,#2
	call setStage
	call show_stage_info


	call player_reset
	call enemy_reset
	call hud_reset
	call map_2_draw
	call initialize_map2

	level2_loop:
;;AQUI EMPIEZA EL NIVEL 2
	call erase_main

	call floor_stage_2_check_collision
	call player_update
	call checkCollision_ia_stage_2

	call draw_update_main

	call hud_vsync_main
	ld a, (main_game_end)
	cp #0
	jp nz, finish

	call checkGoNextLevel
	ld a, b
    	cp #1
    	jr z, redrawmap_3
	jp level2_loop

	redrawmap_3:

		call map_3_draw
		ld a,#3
		call setStage
		call show_stage_info
		call map_3_draw
		ld a,#7
		call show_stage_info2


    	call player_reset
    	call enemy_reset
    	call hud_reset
    	call map_3_draw
    	call initialize_map3
    	call player_ableShot ;;HABILITAMOS EL DISPARO EN ESTE NIVEL
;;AQUI EMPIEZA EL NIVEL 3
    	level3_loop:
    	call erase_main
    	call floor_stage_3_check_collision
    	call player_update
    	call checkCollision_ia_stage_3

    	call draw_update_main

    	call hud_vsync_main

    	ld a, (main_game_end)
    	cp #0
    	jp nz, finish

    	call checkGoNextLevel
	ld a, b
    	cp #1
    	jr z, redrawmap_4
    	jp level3_loop

	redrawmap_4:

	call map_4_draw
	ld a,#4
	call setStage
	call show_stage_info


	call player_reset
	call enemy_reset
	call hud_reset
	call map_4_draw
	call initialize_map4

	level4_loop:

	call erase_main

	call floor_stage_4_check_collision
	call player_update
	call checkCollision_ia_stage_4

	call draw_update_main

	call hud_vsync_main
	ld a, (main_game_end)
	cp #0
	jp nz, finish

	call checkGoNextLevel
	ld a, b
    	cp #1
    	jr z, redrawmap_5
	jp level4_loop

	redrawmap_5:

	call map_5_draw
	ld a,#5
	call setStage
	call show_stage_info

	ld hl, #0x140A
    call cpct_setPALColour_asm
	call player_reset
	call enemy_reset
	call hud_reset
	call map_5_draw

	level5_loop:

	ld a, #0
	call hud_draw_enemy
	call player_erase
	call bulletPlayer_getPtrIX
	call bullet_erase
	call hit_erase
	call enemy_erase

    	call floor_stage_5_check_collision

    	call player_update
    	call player_getPtrIX
    	call enemy_ia

    	call bulletPlayer_getPtrIX
	call checkEnemyCollision

	call hit_getPtrIX
	call checkEnemyCollision

    	call bulletPlayer_getPtrIX
	call bullet_update
	call hit_update
	call bulletPlayer_getPtrIX
	call shoot
	call player_getPtrIX
	call startHit

	call playerCollision

	call bulletPlayer_getPtrIX
	call bullet_draw
	call enemy_draw
	call hit_draw
	call player_draw

	ld a, #0xF0
	call hud_draw_enemy
    	call hud_vsync_main

    	ld a, (main_game_end)
    	cp #0
    	jp nz, finish

    	jp level5_loop


	finish:
	call enemy_checkDirection
	call hud_draw
	call player_reset
	call enemy_reset
	call hud_reset
	ld a, #10
	ld (hud_vsync), a

	finish1:
	call restartMenu
	ld b,a
	cp #0
	jp nz, menu
	jr finish1