.area _DATA
.area _CODE

.globl _g_tileset
.globl _stage_1
.globl _stage_2
.globl _stage_3
.globl _stage_4
.globl _stage_5

map_data:
	videoPtr: .dw #0x8000
	videoIndex: .db #0
	numStage: .db #0

.include "cpctelera.h.s"

map_switchBuffers::
	modifier = .+1
	ld l, #0x20
	call cpct_setVideoMemoryPage_asm
	ld hl, #modifier
	ld a, #0x10
	xor (hl)
	ld (modifier), a

	ld hl, #videoPtr+1
	ld a, #0x40
	xor (hl)
	ld (videoPtr+1), a

	ret

map_getVideoPtr::
	ld hl, (videoPtr)

	ret

map_getVideoIndex::
	ld a, (videoIndex)

	ret

setStage::
	ld (numStage),a
ret
getStage::
	ld a,(numStage)
ret
map_1_draw::

	ld hl, #_g_tileset
	call cpct_etm_setTileset2x4_asm

	ld hl, #0x8000
	ld de, #0x8001
	ld (hl), #00
	ld bc, #0x4000
	ldir

	ld hl, #_stage_1
	push hl

	ld hl, #0xC000
	push hl

	ld bc, #0000

	ld d, #50
	ld e, #40

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ld hl, #_stage_1
	push hl

	ld hl, #0x8000
	push hl

	ld bc, #0000

	ld d, #50
	ld e, #40

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ret

map_2_draw::

	ld hl, #_g_tileset
	call cpct_etm_setTileset2x4_asm

	ld hl, #0x8000
	ld de, #0x8001
	ld (hl), #00
	ld bc, #0x4000
	ldir

	ld hl, #_stage_2
	push hl

	ld hl, #0xC000
	push hl

	ld bc, #0000

	ld d, #50
	ld e, #40

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ld hl, #_stage_2
	push hl

	ld hl, #0x8000
	push hl

	ld bc, #0000

	ld d, #50
	ld e, #40

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ret

map_3_draw::

	ld hl, #_g_tileset
	call cpct_etm_setTileset2x4_asm

	ld hl, #0x8000
	ld de, #0x8001
	ld (hl), #00
	ld bc, #0x4000
	ldir

	ld hl, #_stage_3
	push hl

	ld hl, #0xC000
	push hl

	ld bc, #0000

	ld d, #50
	ld e, #40

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ld hl, #_stage_3
	push hl

	ld hl, #0x8000
	push hl

	ld bc, #0000

	ld d, #50
	ld e, #40

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ret

map_4_draw::

	ld hl, #_g_tileset
	call cpct_etm_setTileset2x4_asm

	ld hl, #0x8000
	ld de, #0x8001
	ld (hl), #00
	ld bc, #0x4000
	ldir

	ld hl, #_stage_4
	push hl

	ld hl, #0xC000
	push hl

	ld bc, #0000

	ld d, #50
	ld e, #40

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ld hl, #_stage_4
	push hl

	ld hl, #0x8000
	push hl

	ld bc, #0000

	ld d, #50
	ld e, #40

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ret

map_5_draw::

	ld hl, #_g_tileset
	call cpct_etm_setTileset2x4_asm

	ld hl, #0x8000
	ld de, #0x8001
	ld (hl), #00
	ld bc, #0x4000
	ldir

	ld hl, #_stage_5
	push hl

	ld hl, #0xC000
	push hl

	ld bc, #0000

	ld d, #50
	ld e, #40

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ld hl, #_stage_5
	push hl

	ld hl, #0x8000
	push hl

	ld bc, #0000

	ld d, #50
	ld e, #40

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ret


mapRedraw::

	push de


	ld a, 0(ix)
	ld b, a
	ld a, 4(ix)
	cp #0
	jr z, der
	inc b
	jr aqui
	der:
	dec b
	aqui:
	ld a, b
	ld b, #2
	ld c, #0
	bucle:
	inc c
	sub b
	


	jp m, divide_y
	jr z, divide_y

	jr bucle

	divide_y:

	dec c

	ld d, #4
	ld a, 5(ix)
	cp #0
	jp p, salta
	jr z, salta

	ld a, 1(ix)

	jr siguelo

	salta:
	ld a, 13(ix)

	siguelo:
	dec a
	cp #124

	jp p, asignar
	jr z, asignar

	jr here

	asignar:
	ld b, #31
	ld e, #124
	sub e
	jr bu

	here:
	ld b, #0

	bu:
	inc b
	sub d
	

	jp m, redibuja
	jr z, redibuja

	jr bu

	redibuja:
	dec b
	;;llamar a redibujar mapa
	pop de

	call getStage
	cp #1
	jr z, stage_uno
	cp #2
	jr z, stage_dos
	cp #3
	jr z, stage_tres
	cp #4
	jr z, stage_cuatro

	ld hl, #_stage_5
	push hl
	jr saltar

	stage_cuatro:
	ld hl, #_stage_4
	push hl
	jr saltar

	stage_tres:
	ld hl, #_stage_3
	push hl
	jr saltar

	stage_dos:
	ld hl, #_stage_2
	push hl
	jr saltar

	stage_uno:
	ld hl, #_stage_1
	push hl

	saltar:
	call map_getVideoPtr
	push hl

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ret