.area _DATA
.area _CODE

;;
;; PRIVATE DATA
;;

.globl _sprite_player0
.globl _sprite_player1
.globl _sprite_player2
.globl _sprite_player3
.globl _sprite_player4
.globl _sprite_player5
.globl _sprite_player6

;;PLAYER DATA
player_data:
	player_x: .db #3
	player_y: .db #150
	player_w: .db #5
	player_h: .db #16
	player_view: .db #0 		;; 0 si mira  a la dcha, 1 si mira a la izq
	player_jump: .db #-1		;; Si -1 el jugador no esta saltando
	player_state: .db #0		;; 0 puede caer, 1 saltando
	contador_sprite: .db #0
	player_hp: .db #60
	player_shot: .db #0
	player_hit: .db #0
	player_checkH: .db #0 		;;flag para hit (evitar mantener pulsado p)
	player_checkS: .db #0 		;;flag para hit (evitar mantener pulsado p)
	player_y_before: .db #0
	player_p_key: .db #1

	
.equ ply_x, 0
.equ ply_y, 1
.equ ply_w, 2
.equ ply_h, 3
.equ ply_v, 4
.equ ply_j, 5
.equ ply_s, 6
.equ ply_cont_spr, 7
.equ ply_shot, 8
.equ ply_hit, 9
.equ ply_hp, 12

;;Tabla de saltos
jumpTable:
	.db #-2, #-5, #-10, #-20, #-15, #-10, #-5, #-2, #-1
	.db #0x80

.include "cpctelera.h.s"
.include "keyboard/keyboard.s"
.include "map.h.s"
.include "bullet.h.s"


;;
;; Public FUNCIONS
;;

player_update::

	call player_gravity
	call checkUserInput
	
	call jump_control
	ld a,#0
	ld (player_state),a
	
	ret
	
player_draw::

	ld a, #0xFF
	call drawPlayer

	ret

player_erase::

	ld a, #0x00
	call drawPlayer

	ret

player_getPtrHL::

	ld hl, #player_x ;;Return player_x memory position

	ret

player_getPtrIX::

	ld IX, #player_data ;;Return player_x memory position

	ret

player_getPtrIY::

	ld IY, #player_data ;;Return player_x memory position

	ret

player_hit_life::
	ld a, (player_hp)
	sub b
	ld (player_hp), a

	ret
player_disableShot::
	ld a,#0
	ld (player_p_key),a
ret
player_ableShot::
	ld a,#1
	ld (player_p_key),a
ret
player_reset::

	;;Player_x
	ld a, #3
	ld (player_x),a

	;;Player_y
	ld a, #150
	ld (player_y),a

	;;Player_hp
	ld a, #60
	ld (player_hp),a

	ld a,#-1
	ld (player_jump),a
	ld a,#0
	ld (player_state),a

	ret

;;==========================================================
;;
;; Uso: Comprueba si el jugador estaba sobre alguna de las plataformas, 
;; 	en caso de estar sobre una de estas se incrementa la variable
;;	player_state, si no esta sobre la plataforma no toca ninguna variable
;;
;; Parametros:	IX apuntando a la plataforma
;;
;; Registros cambiados:	A,B,C,D,E
;;
;;==========================================================

player_checkFloor::
	;;
	;; player_y + player_h >= floor_y   NO COLLISION
	;;  floor_y - (player_y + player_h) <=0
	;;

	;;
	;; Comprobar en Y
	;;
	ld a, (player_h)
	ld b, a			;; Recogemos player_h

	ld a, (player_y)	;; player_Y
	add b			;; Sumar player_y + player_h
	ld b, a			;; Guardar resultado en b
	ld a, ply_y(IX)		;; Recoger floorX_y
	sub b			;; Restar floor_y - (player_y + player_h)

	jr nz, collision_final		;; Si es 0 colisiona
	;;
	;;	Comprobar en X
	;; 
				;; player_x + player_w > floor_x === 0 > floor_x - player_x - player_w
				;; player_x < floor_x + floor_w === 0 < floor_x + floor_w - player_x
	ld a, (player_w)
	ld b, a					;; b = player_w
	ld a, (player_x)
	ld c, a					;; c = player_x
	ld e, ply_w(IX)				;; e = floor_w
	ld d, ply_x(IX)				;; d = floor_x
	ld a, d
	sub c					;; floor_x - player_x
	sub b					;; a - player_w
	jp p, collision_final

	ld a, d					;; a =  floor_x
	add e					;; a + floor_w
	sub c					;; a - player_x
	jp m, collision_final

	ld a, (player_state)			;;
	inc a
	ld (player_state), a

	collision_final:
	ret

checkPlayerCollision::
	  ld a,ply_hp(iy)
	  cp #1
	  jr nz,checkcollision
	  ret
	  checkcollision:
	  ;;COLLISON X: 
	  ;; if (obs_x+obs_w <= hero_x) no collision -> (obs_x+obs_w-hero_x <= 0) 
	  ld a, ply_x(iy)      ;; obs_x 
	  ld c, a         ;; + 
	  ld a, ply_w(iy)      ;; obs_w 
	  add c           ;; -  
	  ld b,0(ix)        ;; enemy_x 
	  sub a,b 
	 
	  jr z,no_colission    ;; if (<= 0) 
	  jp m,no_colission    ;; then no_collision 
	 
	  ;; if (hero_x+hero_w <= obs_x) no collision -> (hero_x+hero_w-obs_x <= 0) 
	  ld a,0(ix) 
	  ld d,2(ix) 
	  add a,d 
	  ld c, a 
	  ld a, ply_x(iy)
	  ld b, a 
	  ld a, c 
	  sub b 
	  jr z,no_colission    ;; if (<= 0) 
	  jp m,no_colission    ;; then no_collision 
	   
	  ;COLLISON Y 
	  ;if (hero_y+hero_h <= obs_y) no collision -> (hero_y+hero_h-obs_y <= 0) 
	   
	  ld a, ply_y(iy)
	  ld c, a 
	  ld a,1(ix) 
	  ld d,3(ix) 
	  add a,d 
	  sub c 
	  jr z,no_colission    ;; if (<= 0) 
	  jp m,no_colission    ;; then no_collision 

	    ;if (obs_y+obs_h <= hero_y) no collision -> (obs_y+obs_h- hero_y <= 0) 
	  ld a, ply_y(iy)      ;; obs_y 
	  ld c, a         ;; + 
	  ld a, ply_h(iy)      ;; obs_w 
	  add c           ;; -  
	  ld d,1(ix) 
	  sub a,d      ;; hero_y 
	  jr z,no_colission    ;; if (<= 0) 
	  jp m,no_colission    ;; then no_collision 

	;;ahora comprobamos si hay un villano en su posicion o es una bala  
	  ld a,2(ix)
	  cp #4
	  jr z,obj_bala
	  ;obj_villain
	  ld a,6(ix)
	  cp #0
	  jr z,no_colission
	  ld b,#1
	  jr collision_hit
	  obj_bala:
	  call borrarBala
	  ld b,#15
	 
	  collision_hit:
	  call player_hit_life
	  no_colission: 
	 
	  ret 
	  ;; if (hero_x+hero_w > obs_x) collision 
	  ;; if (obs_x+obs_w > hero_x) collision 

	ret
;;
;;PRIVATE FUNCTIONS
;;

;;==========================================================
;;
;; Uso: Comprueba si la variable player_state es 0, en caso de 
;;	ser 0 se incrementa dos veces el valor de player_y, 
;;	por lo que el jugador cae
;;
;; Parametros:	Ninguno
;;
;; Registros cambiados:	A
;;
;;==========================================================
player_gravity:

	ld a, (player_state)			;; comprobamos si el jugador puede caer
	cp #0					;; Cuando el jugador colisiona contra alguna plataforma player_state +1
	jr nz, collision

	ld a, (player_y)
	inc a
	inc a
	ld (player_y), a
	add #16
	cp #200
	jr nz, collision

	ld a, #0
	ld (player_hp), a

	collision:

	ret

;;==========================================================
;;
;; Uso: Comprueba que el salto no este empezado con player_jump 
;;	ni el jugador este en caida. Si no esta en ningun caso anterior
;;	cambia la variable salto para dar paso a jump_control
;;
;; Parametros:	Ninguno
;;
;; Registros cambiados:	A
;;
;;==========================================================

startJump:
	ld a, (player_jump)		;; Acceder a player_jump
	cp #-1				;; Si es -1 significa que puede saltar
	ret nz				;; Si no es -1 no puede saltar
	ld a, (player_state)
	cp #0
	ret z
	ld a, #0
	ld (player_jump), a

	ret

;;==========================================================
;;
;; Uso: Realiza el siguiente paso del salto, comprobando que no se pase  del techo y 
;;	si el salto finaliza
;;
;; Parametros:	Ninguno
;;
;; Registros cambiados:	A, B, C, HL
;;
;;==========================================================
jump_control:
	ld a, (player_jump)		;;
	cp #-1				;; Comprueba que el jugador pueda saltar
	ret z				;;

	ld hl, #jumpTable		;; Almacena jumpTable en hl
	ld c, a 			;; 
	ld b, #0			;; Accedemos a la posicion del salto en la que se encuentra el jugador
	add hl, bc			;;

	ld a, (hl)			;;
	cp #0x80			;; Si el puntero esta en 0x80 significa que el salto ha finalizado
	jr z, final_salto		;;

	ld b, a				;;
	ld a, (player_y)		;; Se aplica el valor del puntero a player_y
	ld (player_y_before), a
	add b				;;

	ld (player_y), a

	ld a, (player_jump)		;;
	inc a				;; Incrementa la posicion de player_jump para acceder a la siguiente posicion en la siguiente iteracion
	ld (player_jump), a		;;
	ret

	final_salto:			;;
	ld a, #-1			;; Fin del salto
	ld (player_jump), a		;;

	ret

borrarBala:
	  ld a,#0 
	  ld 5(ix),a 			;;ponemos bullet_first 0
	  ld a,#1
	  ld 7(ix),a  			;;ponemos bullet_finish a 1

	  call bullet_erase
	  ld a,#0 
	  ld 4(ix),a 		;;ponemos bullet_on a 0 		
	  ld a,#1			
	  ld 7(ix),a 		;;ponemos bullet_finish a 1
	  ld a,#0x8000
	  ld 0(ix),a 
	  ld 1(ix),a 
	  call bullet_erase
ret 

obtenerSprite:
	ld a,(player_hp)
	cp #1
	jp p,vive
	ld hl,#_sprite_player6
	ld a,#0
	ret
	vive:
	ld a, (player_jump)
	cp #-1
	jr z,camina
	ld hl,#_sprite_player4
	ld a,#0
	ret
	camina:
	ld a, (contador_sprite)
	cp #0
	jr z, spr1
	cp #5
	jp m, spr2
	cp #10
	jp m, spr3
	cp #15
	jp m, spr4
	ld a,#0
	spr1:	
	ld hl, #_sprite_player0
	ld a,(player_hit)
	cp #0
	jr nz,golpe
	ret
	golpe:
	ld hl, #_sprite_player5	;;el sprite del golpe se aplica sustituyendo al sprite de reposo (el 0), en el caso de que hit sea 1
	jr fin_sprite
	spr2:
	ld hl, #_sprite_player1
	jr fin_sprite
	spr3:
	ld hl, #_sprite_player2
	jr fin_sprite
	spr4:
	ld hl, #_sprite_player3
	ld a,#0
	fin_sprite:


ret

dibujarGiroSprite:		;; Giro, cambiando previamente el valor de player_view de 0 a 1 o viceversa

	ld hl, #_sprite_player6
	ld bc, #0x1005
	call cpct_hflipSpriteMaskedM0_asm

	ld hl, #_sprite_player5
	ld bc, #0x1005
	call cpct_hflipSpriteMaskedM0_asm
	
	ld hl, #_sprite_player4
	ld bc, #0x1005
	call cpct_hflipSpriteMaskedM0_asm

	ld hl, #_sprite_player3
	ld bc, #0x1005
	call cpct_hflipSpriteMaskedM0_asm
	
	ld hl, #_sprite_player2
	ld bc, #0x1005
	call cpct_hflipSpriteMaskedM0_asm
	
	ld hl, #_sprite_player1
	ld bc, #0x1005
	call cpct_hflipSpriteMaskedM0_asm

	ld hl, #_sprite_player0
	ld bc, #0x1005
	call cpct_hflipSpriteMaskedM0_asm
ret

rotateSprite:
	ld a, b 					;; almacenamos el valor de B en A (conocer la tecla pulsada siendo: 1==izq y 0==dcha)
	cp #0						;; comparamos su valor para la condicion
	jr nz, giro_izq				;; 1==giro_izq, 0==giro_dcha
	
	giro_dcha:					;se ha pulsado la d
	ld a, #0					;, girar
	jr fin_rotate

	giro_izq:					;se ha pulsado la a
	ld a, #1					;, girar
	fin_rotate:
		ld (player_view),a 		;; almacenamos la nueva vista del jugador
		call dibujarGiroSprite	;; llamamos al dibujado
	no_girar:			
ret



movePlayerRight:
	ld a, (player_hit)	;;Primero controlamos que no estemos dando el punyetazo 
	cp #0			;;En caso de darlo, debemos estar estaticos, no hay movimiento a la dcha en ese caso
	jr z, goRight
	ret
	goRight:
	ld a, (player_x)
	cp #81-10
	jr z, not_move_right
	call getStage
	cp #5
	jr z, doble_inc

	ld a, (player_x)
	inc a
	jr sigueme

	doble_inc:
	ld a, (player_x)
	inc a
	inc a

	sigueme:
	ld (player_x), a


	ld a, (contador_sprite)
	inc a
	ld (contador_sprite),a
	ld a,(player_view)
	cp #1
	jr nz,not_move_right
	ld b, #0			;; 0 == giro dcha
	call rotateSprite
	
	not_move_right:

ret

movePlayerLeft:
	ld a, (player_hit)      ;;Primero controlamos que no estemos dando el punyetazo 
	cp #0			;;En caso de darlo, debemos estar estaticos, no hay movimiento a la izq en ese caso
	jr z, goLeft
	ret
	goLeft:
	ld	a, (player_x)
	cp #1
	jr z, not_move_left
	jp m, not_move_left
	call getStage
	cp #5
	jr z, doble_dec

	ld a, (player_x)
	dec a
	jr sigueme_1

	doble_dec:
	ld a, (player_x)
	dec a
	dec a

	sigueme_1:
	ld (player_x), a

	ld a, (contador_sprite)
	inc a
	ld (contador_sprite),a
	ld a,(player_view)
	cp #0
	jr nz,not_move_left
	ld b, #1			;; 1 == giro izq
	call rotateSprite
	
	not_move_left:

ret
checkUserInput:
	
	call cpct_scanKeyboard_asm
	ld a,#0					;; almacenamos 0 en A, significando que no se ha pulsado D de momento
	push af					;; guardamos A en la pila, con tal de no perderlo al llamar a la funcion
	ld hl, #Key_D
	call cpct_isKeyPressed_asm

	cp #0					;;Comprobar si D se ha pulsado (nz) o no (z)
	jr nz, d_pressed
	pop af	
	jr keyA	
	
	d_pressed:				;;si se ha pulsado sacamos A de la pila y modificamos el su valor, significando que se ha pulsado D 
	pop af
	ld a,#1
	
	keyA:
	push af
	ld hl, #Key_A
	call cpct_isKeyPressed_asm

	cp #0
	jr z, a_not_pressed		;;Comprobar si A se ha pulsado (nz) o no (z)
	pop af
	inc a
	dec a
	jr nz,fin_teclas		;;Si se ha pulsado A y el valor del registro A es 1, quiere decir que se han pulsado ambas teclas, por lo que no se hace nada (fin de teclas)
	call movePlayerLeft		;;Si solo se ha pulsado A, mover a la izquierda
	jr fin_teclas
	
	a_not_pressed:			;;Si no se ha pulsado A, Comprobamos si se ha pulsado D
	pop af
	inc a
	dec a
	jr z,sin_pulsar

	call	movePlayerRight	; Si solo se ha pulsado D, mover a la dcha
	jr fin_teclas

	sin_pulsar:
	ld a, (contador_sprite)
	ld a,#0
	ld (contador_sprite),a
	fin_teclas:

	ld hl, #Key_W
	call cpct_isKeyPressed_asm

	cp #0
	jr z, w_not_pressed

	call startJump

	w_not_pressed:
	ld a, (player_p_key)		;;comprobamos si los disparos estan habilitados
	cp #0
	jr z,no_p
	;;PARTE EN LA QUE COMPROBAMOS EL TIEMPO DE DELAY DEL DISPARO (P)
	ld a,(player_checkS)
	cp #7
	jp m, no_decremento1			;;comprobamos el valor de check (control de tiempo para armas), si es MENOR QUE 15 (puede variar)
	dec a					;;si es mayor que 15, se le habra asignado un tiempo de retraso alto (70 en este caso), por lo que debemos ir restando hasta llegar a ==16
	ld (player_checkS),a
	cp #8
	jr z, checkS0			;;comprobamos el valor de check (control de tiempo para armas), 
	ld a,#0
	jr fin_teclas2
	checkS0:
	ld a,#0
	ld (player_checkS),a		;;si es 16 (la resta da 0), aplicamos el valor 0 al player_check, reiniciando el disparo
	jr fin_teclas2
	no_decremento1:					

	

	ld hl, #Key_P
	call cpct_isKeyPressed_asm
	cp #0					;;Comprobar si P se ha pulsado (nz) o no (z)
	jr nz, p_pressed

	;;EN CASO DE NO PULSAR P:
	ld a,#0					;;aqui solo ponemos el valor de player shot a 0 (primero en a, pero al saltar a fin_teclas 2 se incializa el valor en player shot)

	jr fin_teclas2

	;;EN CASO DE SI PULSAR P:
	p_pressed:
	ld a,(player_checkS)			;;si se ha pulsao P, comparamos el valor de player_check con 12. 
	cp #6					;;TIEMPO DURACION ANIMACION 					
	jp p, fuera1
	inc a					;;si este valor es inferior se sigue incrementando (mientras se siga pulsando p) hasta que sea 12, hasta entonces dispara
	ld (player_checkS),a			
	ld a,#1					;;se pone el valor de shot a 1 para disparar (llama al dibujado de la clase bullet)
	jr fin_teclas2
	fuera1:					;; si el valor es superior, lo que se hacer es poner el disparo a 0, con tal de que deje de disparar, y poner player_check con un determinado tiempo de espera para volver a disparar
	ld a,#50				;;TIEMPO DE RECARGA (SIN PULSAR NADA), EN CASO DE SOBRECARGA DE TECLA
	ld (player_checkS),a
	ld a,#0
	
	fin_teclas2:			;;damos el valor de 'a' a player shot
	ld b,a
	ld (player_shot),a

	no_p:

	;;PARTE EN LA QUE COMPROBAMOS EL TIEMPO DE DELAY DEL GOLPEO (O)
	ld a,(player_checkH)
	cp #5
	jp m, no_decremento2			;;comprobamos el valor de check (control de tiempo para armas), si es MENOR QUE 19 (puede variar)
	dec a					;;si es mayor que 19, se le habra asignado un tiempo de retraso alto (60 en este caso), por lo que debemos ir restando hasta llegar a ==20
	ld (player_checkH),a
	cp #6
	jr z, checkH0			;;comprobamos el valor de check (control de tiempo para armas),
	ld a,#0
	jr fin_teclas3
	checkH0:			;; si es 0 significa que ya se puede pulsar para golpear
	ld a,#0
	ld (player_checkH),a
	jr fin_teclas3
	no_decremento2:				;;si no es 0, tenemos que ir decrementando poco a poco el valor de player check hasta que sea 0, para volver a poder disparar


	ld hl, #Key_O				;;LO MISMO QUE ANTES PERO AHORA PARA O (HIT)
	call cpct_isKeyPressed_asm
	cp #0					;;Comprobar si O se ha pulsado (nz) o no (z)
	jr nz, o_pressed

	;;EN CASO DE NO PULSAR O:
	ld a,#0					;;si no se ha pulsado O el comprobador se pone siempre a 0 (reset check de hit)
	jr fin_teclas3


	;;EN CASO DE SI PULSAR O:
	o_pressed:
	ld a,(player_checkH)			;;si se ha pulsao O, comparamos el valor de player_check con 20. 
	cp #4				
	jp p, fuera
	inc a					;;si este valor es inferior se sigue incrementando (mientras se siga pulsando o) hasta que sea 20
	ld (player_checkH),a			
	ld a,#1					;;se pone el valor de hit a 1 para disparar (llama al dibujado de la clase hit)
	jr fin_teclas3

	fuera:					;; si el valor es superior, lo que se hacer es poner el hit a 0, con tal de que deje de golpear, y poner player_check con un determinado tiempo de espera para volver a golpear
	ld a,#40				
	ld (player_checkH),a
	ld a,#0

	fin_teclas3:
	ld c,a
	ld (player_hit),a

	ld a, (player_p_key)		;;comprobamos si los disparos estan habilitados
	cp #0
	jr z,no_p2

	ld a,c
	cp #1
	jr z,o_pulsada
	ret
	o_pulsada:			;;comprobamos que no se este pulsado o y p a la vez (solo se efectua la o en ese caso)
	ld a,#0

	ld (player_shot),a
	no_p2:
ret

drawPlayer:
	push af ;; Guardar a en pila
	;;CAlcular Screen position
	call map_getVideoPtr
	ex de, hl
	ld a,  (player_x)		;;No se puede pasar player_x a C inmediatamente
	ld c, a
	ld a,  (player_y)		;;No se puede pasar player_y a B inmediatamente
	ld b, a
	call cpct_getScreenPtr_asm	;; Llamar a la funcion

	;;Draw box
	ex de, HL	;;Intercambiar posiciones de DE y HL
	ld bc, #0x1005		;;16x10 pixeles
	pop af
	cp #00
	jr z, erasePlayer

	call obtenerSprite

	ld (contador_sprite),a
	call cpct_drawSpriteMasked_asm

	

	ret
	erasePlayer:

	;call cpct_drawSolidBox_asm
	call player_getPtrIX
	ld d, #5
	ld e, #4
	call mapRedraw

	ret