.area _DATA
.area _CODE


.globl _stage_1
.globl _stage_2
.globl _stage_3
.globl _stage_4
.globl _stage_5

.globl _sprite_villain_green
.globl _sprite_villain_blue
.globl _sprite_villain_orange
.globl _sprite_villain_pink
.globl _sprite_villain4

.globl _sprite_villain_green_hit
.globl _sprite_villain_blue_hit
.globl _sprite_villain_pink_hit
.globl _sprite_villain_orange_hit

.include "cpctelera.h.s"
.include "bullet.h.s"
.include "hit.h.s"
.include "player.h.s"
.include "map.h.s"



;;enemigo que espera quieto hasta que el jugador se acerca y entonces le asesta un punyetazo que le quita toda la vida - muere de un golpe
villain_0:
	
	villain0_x: .db #58
	villain0_y: .db #172
	villain0_w: .db #5
	villain0_h: .db #16
	villain0_direction: .db #1 ;variable que almacena la direccion del movimiento del enemigo // 0 == derecha -- 1 == izquierda
	villain0_jumping: .db #0	; 0 == no salta, 1 == saltando
	villain0_hp: .db #5      ;; Vida del enemigo. Se usa con registro IX, no cambiar posicion 
	villain0_hit_player: .db #0 ; variable para comprobar que el enemigo ha tocado al jugador	
	villain0_number: .db #0 ; numero para identificar al enemigo
	villain0_shot: .db #0

;;enemigo que dispara estatico
villain_1:	
	
	villain1_x: .db #70
	villain1_y: .db #56
	villain1_w: .db #5
	villain1_h: .db #16
	villain1_direction: .db #1 ;variable que almacena la direccion del movimiento del enemigo // 0 == derecha -- 1 == izquierda
	villain1_jumping: .db #0	; 0 == no salta, 1 == saltando
	villain1_hp: .db #10     ;; Vida del enemigo. Se usa con registro IX, no cambiar posicion 
	villain1_hit_player: .db #0 ; variable para comprobar que el enemigo ha tocado al jugador	
	villain1_number: .db #1 ; numero para identificar al enemigo
	villain1_shot: .db #0


;;enemigo que va hacia el jugador a golpearle, quitandole 20hp de la vida en cada golpe, muere de dos golpes
villain_2:		
	
	villain2_x: .db #7
	villain2_y: .db #116
	villain2_w: .db #5
	villain2_h: .db #16
	villain2_direction: .db #0 ;variable que almacena la direccion del movimiento del enemigo // 0 == derecha -- 1 == izquierda
	villain2_jumping: .db #0	; 0 == no salta, 1 == saltando
	villain2_hp: .db #10      ;; Vida del enemigo. Se usa con registro IX, no cambiar posicion 
	villain2_hit_player: .db #0 ; variable para comprobar que el enemigo ha tocado al jugador
	villain2_number: .db #2 ; numero para identificar al enemigo
	villain2_shot: .db #0	;identificar si la bala esta activa


villain_3:		
	
	villain3_x: .db #65
	villain3_y: .db #174
	villain3_w: .db #5
	villain3_h: .db #16
	villain3_direction: .db #0 ;variable que almacena la direccion del movimiento del enemigo // 0 == derecha -- 1 == izquierda
	villain3_jumping: .db #0	; 0 == no salta, 1 == saltando
	villain3_hp: .db #0   ;; Vida del enemigo. Se usa con registro IX, no cambiar posicion 
	villain3_hit_player: .db #0 ; variable para comprobar que el enemigo ha tocado al jugador
	villain3_number: .db #3 ; numero para identificar al enemigo
	villain3_shot: .db #0	;identificar si la bala esta activa


;; Enemigo que sigue al jugador en el eje Y sobre el borde derecho de la pantalla, colocandose a la altura de la plataforma en la que se encuentre el jugador
villain_4:

	villain4_x: .db #65
	villain4_y: .db #174
	villain4_w: .db #10
	villain4_h: .db #16
	villain4_direction: .db #1 ;variable que almacena la direccion del movimiento del enemigo // 0 == derecha -- 1 == izquierda
	villain4_jumping: .db #0	; 0 == no salta, 1 == saltando
	villain4_hp: .db #0   ;; Vida del enemigo. Se usa con registro IX, no cambiar posicion 
	villain4_hit_player: .db #0 ; variable para comprobar que el enemigo ha tocado al jugador
	villain4_number: .db #4 ; numero para identificar al enemigo
	villain4_shot: .db #0	;identificar si la bala esta activa

floorY_1_stage3: .db #190
floorY_2_stage3: .db #140
floorY_3_stage3: .db #90

.equ vill_x, 0
.equ vill_y, 1
.equ vill_w, 2
.equ vill_h, 3
.equ vill_direction, 4
.equ vill_jumping, 5
.equ vill_hp, 6
.equ vill_hit_player, 7
.equ vill_number, 8
.equ villain_shot, 9



;;============================================================
;;FUNCIONES PUBLICAS
;;============================================================


villain_draw::
	ld IX, #villain_0
	call draw_v

	checkv1:
	ld IX, #villain_1
	call draw_v

	checkv2:
	ld IX, #villain_2
	call draw_v

	checkv3:
	ld IX, #villain_3
	call draw_v
	
	checkv4:
	ld IX, #villain_4
	call draw_v

	ret
draw_v:
	ld a, vill_hp(ix)
	cp #0
	jr nz, seguirDibujando
	jr checkv
	seguirDibujando:
	ld a, #0xFF
	call drawVillain 
	checkv:

ret

;;funcion para borrar el enemigo
villain_erase::
	call getStage
	cp #1
	jr z,stage1
	cp #2
	jr z,stage2
	cp #3
	jr z,stage3
	cp #4
	jr z,stage4
	
	stage1:
	call villain_erase0
	call villain_erase1
	call villain_erase2
	ret
	stage2:
	call villain_erase0
	call villain_erase1
	call villain_erase3
	ret
	stage3:
	call villain_erase2
	;call villain_erase1
	call villain_erase3
	call villain_erase4
	ret
	stage4:			;;con tal de que no de lag en este nivel (4 enemigos) los enemigos estaticos solo se dibujan
	;call villain_erase1
	call villain_erase3
	call villain_erase2
	;call villain_erase0

	ret
villain_erase4:
	ld a, #0x00 ;;para dibujar en color del fondo 
	ld IX, #villain_4
	call drawVillain 
ret
villain_erase3:
	ld a, #0x00 ;;para dibujar en color del fondo 
	ld IX, #villain_3
	call drawVillain 
ret
villain_erase2:
	ld a, #0x00 ;;para dibujar en color del fondo 
	ld IX, #villain_2
	call drawVillain 
ret
villain_erase1:
	ld a, #0x00 ;;para dibujar en color del fondo 
	ld IX, #villain_1
	call drawVillain 
ret
villain_erase0:
	ld a, #0x00 ;;para dibujar en color del fondo 
	ld IX, #villain_0
	call drawVillain 
ret
;;funcion que llama a las distintas ia's presentes en el stage 1
checkCollision_ia_stage_1::	

	;;aqui solo colisiona el golpe del jugador con el enemigo, nada de balas (del player)

	call villain0_getPtrIY	
	call hit_getPtrIX
	call checkVillainCollision

	call villain1_getPtrIY	
	call hit_getPtrIX
	call checkVillainCollision

	call villain2_getPtrIY				
	call hit_getPtrIX
	call checkVillainCollision

	;;tras comprobar las colisiones activamos la ia

	ld ix, #villain_0
	call checkIAHP

	ld ix, #villain_2
	call checkIAHP

	ld ix,#villain_1
	call checkIAHP

	ret

checkGoNextLevel::

	ld b, #1

	ld IX, #villain_0
	call countVillain

	ld IX, #villain_1
	call countVillain

	ld IX, #villain_2
	call countVillain

	ld IX, #villain_3
	call countVillain

	ld IX, #villain_4
	call countVillain
	


	ret
countVillain:
	ld a, vill_hp(ix)
	cp #0
	jr z, contar
	ld b,#0
	contar:
	ret
ret
initialize_map1::

	ld ix, #villain_0
	ld vill_hp(ix), #5
	ld vill_y(ix), #172
	ld vill_x(ix), #58
	ld a,vill_direction(ix)
	cp #0
	jr nz,not_rot_v0
	ld b, #1			;; 1 == giro izq
	ld c,vill_number(ix)
	call rotateSprite

	not_rot_v0:
	ld ix, #villain_1
	ld vill_hp(ix), #15
	ld vill_y(ix), #56
	ld vill_x(ix), #70
	ld villain_shot(ix),#0
	ld a,vill_direction(ix)
	cp #0
	jr nz,not_rot_v1
	ld b, #1			;; 1 == giro izq
	ld c,vill_number(ix)
	call rotateSprite

	not_rot_v1:
	ld ix, #villain_2
	ld vill_hp(ix), #10
	ld vill_y(ix), #116
	ld vill_x(ix), #7
	ld a,vill_direction(ix)
	cp #1
	jr nz,not_rot_v2
	ld b, #0			;; 1 == giro izq
	ld c,vill_number(ix)
	call rotateSprite

	not_rot_v2:
	ld ix, #villain_3
	ld vill_hp(ix), #0
	ld villain_shot(ix),#0
	ld a,vill_direction(ix)
	cp #0
	jr nz,not_rot_view3
	ld b, #1			;; 1 == giro izq
	ld c,vill_number(ix)
	call rotateSprite
	not_rot_view3:
	ld ix, #villain_4
	ld vill_hp(ix), #0
	ld villain_shot(ix),#0

	ret
initialize_map2::

	ld ix, #villain_0
	ld vill_hp(ix), #5
	ld vill_y(ix), #132
	ld vill_x(ix), #18

	ld ix, #villain_1
	ld vill_hp(ix), #15
	ld vill_y(ix), #64
	ld vill_x(ix), #74

	ld ix, #villain_3
	ld vill_hp(ix), #10
	ld vill_y(ix), #172
	ld vill_x(ix), #65
	ld a,vill_direction(ix)
	cp #0
	jr nz,not_rot_v3
	ld b, #1			;; 1 == giro izq
	ld c,vill_number(ix)
	call rotateSprite
	not_rot_v3:
	call player_getPtrIX
	ld 0(ix), #3
	ld 1(ix), #150

	ret
initialize_map3::
	ld ix, #villain_4
	ld vill_hp(ix), #25
	ld vill_y(ix), #30
	ld vill_x(ix), #70
	ld vill_direction(ix),#1

   	ld ix, #villain_3
	ld vill_hp(ix), #10
	ld vill_y(ix), #124
	ld vill_x(ix), #58
	ld a,vill_direction(ix)
	cp #0
	jr nz,not_rot_v03
	ld b, #1			;; 1 == giro izq
	ld c,vill_number(ix)
	call rotateSprite
	not_rot_v03:
	ld ix, #villain_2
	ld vill_hp(ix), #10
	ld vill_y(ix), #172
	ld vill_x(ix), #50
	ld a,vill_direction(ix)
	cp #1
	jr nz,not_rot_v02
	ld b, #0			;; 1 == giro izq
	ld c,vill_number(ix)
	call rotateSprite

	not_rot_v02:


    call player_getPtrIX
    ld 0(ix), #3
    ld 1(ix), #150

    ret

initialize_map4::

	ld ix, #villain_2
	ld vill_hp(ix), #10
	ld vill_y(ix), #60
	ld vill_x(ix), #20

	ld ix, #villain_1
	ld vill_hp(ix), #15
	ld vill_y(ix), #96
	ld vill_x(ix), #1

	ld a,vill_direction(ix)
	cp #1
	jr nz,not_rot_v01
	ld b, #0			;; 1 == giro izq
	ld c,vill_number(ix)
	call rotateSprite
	;ld vill_direction(ix),#0

	not_rot_v01:
	ld ix, #villain_3
	ld vill_hp(ix), #10
	ld vill_y(ix), #132
	ld vill_x(ix), #74
	ld a,vill_direction(ix)
	cp #0
	jr nz,not_rot_v003
	ld b, #1			;; 1 == giro izq
	ld c,vill_number(ix)
	call rotateSprite
	;ld vill_direction(ix),#1

	not_rot_v003:
	ld ix, #villain_0
	ld vill_hp(ix), #5
	ld vill_y(ix), #60
	ld vill_x(ix), #30
	ld a,vill_direction(ix)
	cp #0
	jr nz,not_rot_v00
	ld b, #1			;; 1 == giro izq
	ld c,vill_number(ix)
	call rotateSprite

	not_rot_v00:
	call player_getPtrIX
	ld 0(ix), #36
	ld 1(ix), #150

	ret
checkIAHP:
	
	ld a, vill_number(ix)
	cp #0
	jp z, num_zero
	cp #1
	jp z, num_one
	cp #2
	jp z, num_two
	cp #3
	jp z, num_three
	;num_4
	ld a, vill_hp(ix)
	cp #0
	jr z, muerto4
	call villain4_ia
	ret
	num_zero:	;;si no esta muerto llamamos a su IA
	ld a, vill_hp(ix)
	cp #0
	jr z, muerto0
	call villain0_ia
	ret

	num_one:	;;si no esta muerto llamamos a su IA
	ld a, vill_hp(ix)
	cp #0
	jr z, muerto1
	call player_getPtrIX
	ld a, 1(IX)		;; b = player_y
	ld e, 0(IX)		;; b = player_x
	call villain1_getPtrIX	;;comprobar tiro del enemigo 1 (en funcion de si el personaje esta en la misma y)
	call villain1_ia
	ret

	num_two:  ;;si no esta muerto llamamos a su IA
	ld a, vill_hp(ix)
	cp #0
	jr z, muerto
	call villain2_ia
	ret

	num_three:	;;si no esta muerto llamamos a su IA
	ld a, vill_hp(ix)
	cp #0
	jr z, muerto3
	call villain3_ia
	ret
	
	muerto1:
	ld a,#0
	ld (villain1_shot),a
	call getStage			;; borramos el enemigo en el stage 4 ya que de normal no se borra (en ese stage)
	cp #4
	call z,villain_erase1
	ret
	muerto4:
	ld a,#0
	ld (villain4_shot),a
	ret
	muerto3:
	ld a,#0
	ld (villain3_shot),a
	ld vill_hit_player(ix),a
	muerto0:
	call getStage			;; borramos el enemigo en el stage 4 ya que de normal no se borra
	cp #4
	call z,villain_erase0
	muerto:
	ret
	
ret

checkCollision_ia_stage_4::    
	call villain0_getPtrIY
	call bulletPlayer_getPtrIX
	call checkVillainCollision

	call villain0_getPtrIY    
    call hit_getPtrIX
    call checkVillainCollision

	call villain1_getPtrIY
	call bulletPlayer_getPtrIX
	call checkVillainCollision

	call villain1_getPtrIY    
    call hit_getPtrIX
    call checkVillainCollision

    call villain3_getPtrIY
	call bulletPlayer_getPtrIX
	call checkVillainCollision

	call villain3_getPtrIY    
    call hit_getPtrIX
    call checkVillainCollision
    
    call villain2_getPtrIY
	call bulletPlayer_getPtrIX
	call checkVillainCollision

	call villain2_getPtrIY    
    call hit_getPtrIX
    call checkVillainCollision


    ;;tras comprobar las colisiones activamos la ia

	ld ix, #villain_3
	call checkIAHP

	ld ix, #villain_2
	call checkIAHP	
	ld ix, #villain_1
	call checkIAHP	
	ld ix, #villain_0
	call checkIAHP	
    
    ret	
checkCollision_ia_stage_3::    
	call villain4_getPtrIY
	call bulletPlayer_getPtrIX
	call checkVillainCollision

	call villain4_getPtrIY    
    call hit_getPtrIX
    call checkVillainCollision

    call villain3_getPtrIY
	call bulletPlayer_getPtrIX
	call checkVillainCollision

	call villain3_getPtrIY    
    call hit_getPtrIX
    call checkVillainCollision
    
    call villain2_getPtrIY
	call bulletPlayer_getPtrIX
	call checkVillainCollision

	call villain2_getPtrIY    
    call hit_getPtrIX
    call checkVillainCollision


    ;;tras comprobar las colisiones activamos la ia

    call villain4_getPtrIX
    call checkIAHP


	ld ix, #villain_3
	call checkIAHP

	ld ix, #villain_2
	call checkIAHP	
	;ld ix, #villain_1 					;al poner este enemigo el juego daba lag (sobre todo por el erase)
	;call checkIAHP	
    
    ret

checkCollision_ia_stage_2::	
	;;aqui solo colisiona el golpe del jugador con el enemigo, nada de balas (del player)
	call villain0_getPtrIY	
	call hit_getPtrIX
	call checkVillainCollision

	call villain3_getPtrIY	
	call hit_getPtrIX
	call checkVillainCollision

	call villain1_getPtrIY				
	call hit_getPtrIX
	call checkVillainCollision

	ld ix, #villain_3
	call checkIAHP

	ld ix, #villain_0
	call checkIAHP

	call villain1_getPtrIX	;;comprobar tiro del enemigo 1 (en funcion de si el personaje esta en la misma y)
	call checkIAHP	
	ret
;;============================================================
;;FUNCIONES PRIVADAS
;;============================================================

;;ia del enemigo 0
villain0_ia:
	call player_getPtrIX
	ld a, 0(ix)
	add 2(ix)
	ld ix, #villain_0
	sub vill_x(ix)

	jp m, izq
	jp z, golpea_0

	ld a, vill_x(ix)
	add vill_w(ix)
	call player_getPtrIX
	sub 0(ix)

	jp m, der
	jp z, golpea_0

	izq:
	ld ix, #villain_0
	ld a, vill_direction(ix)
	cp #0
	jr z, girar_izq_0

	ret

	girar_izq_0:
	ld b, #1		
	ld c,vill_number(ix)
	call rotateSprite
	ret

	der:
	ld ix, #villain_0
	ld a, vill_direction(ix)
	cp #1
	jr z, girar_der_0

	ret

	girar_der_0:
	ld b, #0		
	ld c,vill_number(ix)
	call rotateSprite
	ret


	golpea_0:
	call player_getPtrIX
	ld a, 1(ix)
	ld ix, #villain_0
	sub vill_y(ix)
	cp #0
	jr z, hit_0

	ret

	hit_0:
	ld a, #1
	ld vill_hit_player(ix), a
	ld a, #60
	ld b, a
	call player_hit_life




	ret


;;ia del enemigo 2
villain2_ia:

	ld ix, #villain_2
	ld a, vill_y(ix)
	call player_getPtrIX
	sub 1(ix)

	jr z, misma_altura

	ret

	misma_altura:
	ld a, 0(ix)
	ld ix, #villain_2
	sub vill_x(ix)
	jp z, golpea
	jp p, para_derecha
	jp m, para_izquierda

	para_derecha:
	cp #3
	jr z, golpea
	ret m

	ld a, vill_x(ix)
	inc a
	ld vill_x(ix), a

	ld a,vill_direction(ix)
	cp #1
	jr nz,not_move_right
	ld b, #0			;; 0 == giro dcha
	ld c,vill_number(ix)
	call rotateSprite
	not_move_right:
	ret

	para_izquierda:
	cp #-3
	jr z, golpea
	ret p

	ld a, vill_x(ix)
	dec a
	ld vill_x(ix), a

	ld a,vill_direction(ix)
	cp #0
	jr nz,not_move_left
	ld b, #1			;; 1 == giro izq
	ld c,vill_number(ix)
	call rotateSprite
	not_move_left:
	ret

	golpea:
	ld a, #1
	ld vill_hit_player(ix), a
	ld a, #10
	ld b, a
	call player_hit_life

	ret

villain1_ia:
	ld c,vill_y(ix)
	sub a,c
	cp #0
	jr z,dispara		
	ret
	dispara:
	ld a, vill_hp(ix)
	cp #0
	jr nz,dispara2
	ld a,#0
	ld (villain1_shot),a
	ret
	dispara2:
	ld a,#1
	ld (villain1_shot),a
ret

villain3_shoot:
	ld ix, #villain_3
	ld a, vill_hp(ix)
	cp #0
	jr nz,dispara4
	ld a,#0
	ld vill_hit_player(ix),#0
	ld (villain3_shot),a
	ret
	dispara4:
	ld a,#1
	ld vill_hit_player(ix),#1
	ld (villain3_shot),a
ret

villain3_ia:

	ld ix, #villain_3
	ld vill_hit_player(ix),#0

	ld a, vill_y(ix)
	call player_getPtrIX
	sub 1(ix)
	jr z, misma_altura3

	ret

	misma_altura3:
	ld a, 1(ix)
	ld b,a
	ld a, 0(ix)
	cp #40
	jp p, no_llamar_disparo
	llamar_disparo:
	ld ix, #villain_3	
	ld a,vill_direction(ix)
	cp #0
	jr nz, no_girar_sprite

	ld b, #1		;; 1 == giro izq
	ld c,vill_number(ix)
	call rotateSprite

	no_girar_sprite:
	call villain3_shoot
	ret
	no_llamar_disparo:		;;esta cerca del enemigo lo atacamos de cerca 
	call getStage			;; en el stage4 su funcion solo es disparar
	cp #4
	jr z,llamar_disparo

	ld a,#0
	ld (villain3_shot),a

	call player_getPtrIX
	ld a, 0(ix)
	ld ix, #villain_3
	sub vill_x(ix)
	jp z, golpea3
	jp p, para_derecha3
	jp m, para_izquierda3

	para_derecha3:
	cp #4
	jr z, golpea3
	ret m

	ld a, vill_x(ix)
	inc a
	ld vill_x(ix), a

	ld a,vill_direction(ix)
	cp #1
	jr nz,not_move_right3
	ld b, #0			;; 0 == giro dcha
	ld c,vill_number(ix)
	call rotateSprite
	not_move_right3:
	ret

	para_izquierda3:
	cp #-4
	jr z, golpea3
	ret p

	ld a, vill_x(ix)
	dec a
	ld vill_x(ix), a

	ld a,vill_direction(ix)
	cp #0
	jr nz,not_move_left3
	ld b, #1			;; 1 == giro izq
	ld c,vill_number(ix)
	call rotateSprite
	not_move_left3:
	ret

	golpea3:
	ld vill_hit_player(ix),#1
	ld b, #10
	call player_hit_life

	ret


villain4_ia:
    
	call player_getPtrIX
	ld IY, #villain_4

    ;; PASO 1: Comprobar si coinciden las y

	ld a, vill_y(IX)
	cp vill_y(IY)
	jr z,  vill4_shoot

    ;; PASO 2: direccion de movimiento y si colisiona con los bordes superiores e inferiores

   ld a, vill_jumping(IY)
   cp #0
   jr nz, vill4_down

   	;vill4_up:
 
    ld a, vill_y(IY)
    cp #20
    jr z, vill4_changeDir
    dec a
    dec a
    ld vill_y(IY), a

    jr vill_end
    vill4_down:

    ld a, vill_y(IY)
    cp #172
    jr z, vill4_changeDir
    inc a
    inc a
    ld vill_y(IY), a

    jr vill_end

	vill4_changeDir:
	ld a, vill_jumping(IY)
	cp #0
	jr z, change_1

	ld a, #0
	ld vill_jumping(IY), a

	jr vill_end

	change_1:
	ld a, #1
	ld vill_jumping(IY), a

	jr vill_end

    vill4_shoot:
	ld a,#1
	ld (villain4_shot),a

    vill_end:


    ret

rotateSprite:
	ld a, b 					;; almacenamos el valor de B en A (conocer la tecla pulsada siendo: 1==izq y 0==dcha)
	cp #0						;; comparamos su valor para la condicion
	jr nz, giro_izq				;; 1==giro_izq, 0==giro_dcha
	
	giro_dcha:					;se ha pulsado la d
	ld a, #0								;, girar
	jr fin_rotate

	giro_izq:					;se ha pulsado la a
	ld a, #1					;, girar
	fin_rotate:
		ld vill_direction(ix),a 		;; almacenamos la nueva vista del jugador
		ld a,c 
		cp #2
		jr z, giro_spr2
		cp #0
		jr z, giro_spr0
		cp #1
		jr z, giro_spr1
		giro_spr3:
		ld hl, #_sprite_villain_orange
		ld bc, #0x1005
		call cpct_hflipSpriteMaskedM0_asm
		ld hl, #_sprite_villain_orange_hit
		ld bc, #0x1005
		call cpct_hflipSpriteMaskedM0_asm
		ret
		giro_spr2:
		ld hl, #_sprite_villain_pink
		ld bc, #0x1005
		call cpct_hflipSpriteMaskedM0_asm
		ld hl, #_sprite_villain_pink_hit
		ld bc, #0x1005
		call cpct_hflipSpriteMaskedM0_asm
		ret
		giro_spr0:
		ld hl, #_sprite_villain_green
		ld bc, #0x1005
		call cpct_hflipSpriteMaskedM0_asm	;; llamamos al dibujado
		ld hl, #_sprite_villain_green_hit
		ld bc, #0x1005
		call cpct_hflipSpriteMaskedM0_asm
		ret
		giro_spr1:
		ld hl, #_sprite_villain_blue
		ld bc, #0x1005
		call cpct_hflipSpriteMaskedM0_asm	;; llamamos al dibujado
		ld hl, #_sprite_villain_blue_hit
		ld bc, #0x1005
		call cpct_hflipSpriteMaskedM0_asm
		ret
	no_girar:			
ret


;;funciones para devolver los punteros de cada tipo de enemigo
villain0_getPtrIX::
	ld ix, #villain_0
	ret
villain1_getPtrIX::
	ld ix, #villain_1
	ret
villain2_getPtrIX::
	ld ix, #villain_2
	ret
villain3_getPtrIX::
	ld ix, #villain_3
	ret
villain4_getPtrIX::
	ld ix, #villain_4
	ret

villain0_getPtrIY::
	ld iy, #villain_0
	ret
villain1_getPtrIY::
	ld iy, #villain_1
	ret
villain2_getPtrIY::
	ld iy, #villain_2
	ret
villain3_getPtrIY::
	ld iy, #villain_3
	ret
villain4_getPtrIY::
	ld iy, #villain_4
	ret

checkVillainCollision::
	  ld a,vill_hp(iy)
	  cp #0
	  jr nz,checkcollision
	  ret
	  checkcollision:
	  ;;COLLISON X: 
	  ;; if (obs_x+obs_w <= hero_x) no collision -> (obs_x+obs_w-hero_x <= 0) 
	  ld a, vill_x(iy)      ;; obs_x 
	  ld c, a         ;; + 
	  ld a, vill_w(iy)      ;; obs_w 
	  add c           ;; -  
	  ld b,0(ix)        ;; enemy_x 
	  sub a,b 
	 
	  jr z,no_colission    ;; if (<= 0) 
	  jp m,no_colission    ;; then no_collision 
	 
	  ;; if (hero_x+hero_w <= obs_x) no collision -> (hero_x+hero_w-obs_x <= 0) 
	  ld a,0(ix) 
	  ld d,2(ix) 
	  add a,d 
	  ld c, a 
	  ld a, vill_x(iy)
	  ld b, a 
	  ld a, c 
	  sub b 
	  jr z,no_colission    ;; if (<= 0) 
	  jp m,no_colission    ;; then no_collision 
	   
	  ;COLLISON Y 
	  ;if (hero_y+hero_h <= obs_y) no collision -> (hero_y+hero_h-obs_y <= 0) 
	   
	  ld a, vill_y(iy)
	  ld c, a 
	  ld a,1(ix) 
	  ld d,3(ix) 
	  add a,d 
	  sub c 
	  jr z,no_colission    ;; if (<= 0) 
	  jp m,no_colission    ;; then no_collision 

	    ;if (obs_y+obs_h <= hero_y) no collision -> (obs_y+obs_h- hero_y <= 0) 
	  ld a, vill_y(iy)      ;; obs_y 
	  ld c, a         ;; + 
	  ld a, vill_h(iy)      ;; obs_w 
	  add c           ;; -  
	  ld d,1(ix) 
	  sub a,d      ;; hero_y 
	  jr z,no_colission    ;; if (<= 0) 
	  jp m,no_colission    ;; then no_collision 

	  ld a,8(ix)
	  cp #0
	  jr z,golpe
	  ;bala
	  call borrarBala
	  jr life
	  golpe:
	  ld a,9(ix)
	  cp #0
	  jr z,golpesinvida
	  call borrarGolpe
	  life:
	  call restarVida
	 
	  no_colission: 
	 
	  ret 
	  ;; if (hero_x+hero_w > obs_x) collision 
	  ;; if (obs_x+obs_w > hero_x) collision 
	golpesinvida:

	ret

borrarBala:
	  ld a,#0 
	  ld 5(ix),a 			;;ponemos bullet_first 0
	  ld a,#1
	  ld 7(ix),a  			;;ponemos bullet_finish a 1

	  call bullet_erase
	  ld a,#0 
	  ld 4(ix),a 		;;ponemos bullet_on a 0 		
	  ld a,#1			
	  ld 7(ix),a 		;;ponemos bullet_finish a 1
	  ld a,#0x8000
	  ld 0(ix),a 
	  ld 1(ix),a 
	  call bullet_erase
ret 
borrarGolpe:
	ld a,#0
	ld 9(ix),a

ret 	
restarVida: 		;;Restamos a partir de la colision comprobada

	  fin_direccion:
	  ld a,vill_hp(iy)
	  cp #0
	  jr nz,restar
	  ;;jp p,restar
	  ret
	  restar:
	  sub #5
	  ld vill_hp(iy),a
	  ret 
ret

drawVillain:
	push af ;; Guardar a en pila

	;;CAlcular Screen position
	call map_getVideoPtr
	ex de, hl
	ld a,  vill_x(ix)		
	ld c, a
	ld a,  vill_y(ix)		
	ld b, a
	call cpct_getScreenPtr_asm	;; Llamar a la funcion
	ld a, vill_number(ix)
	cp #4
	jr z,vll_04 
	ld bc, #0x1005	
	jr sigue_dibujado
	vll_04:
	ld bc, #0x100A
	sigue_dibujado:
	ex de, HL	;;Intercambiar posiciones de DE y HL
	pop af
	cp #0
	jp z, eraseVillain
	
	ld a, vill_number(ix)
	cp #0
	jp z, number_zero

	cp #1
	jp z, number_one
	cp #2
	jr z, number_two
	cp #3
	jr z, number_three
	;;number_four
	ld hl, #_sprite_villain4
	call cpct_drawSpriteMasked_asm
	ret
	number_three:
	ld a, vill_hit_player(ix)
	cp #0
	jr z, no_hay_golpe_3

	ld a, #0
	ld vill_hit_player(ix), a
	ld hl, #_sprite_villain_orange_hit
	call cpct_drawSpriteMasked_asm
	ret

	no_hay_golpe_3:
	ld hl, #_sprite_villain_orange
	call cpct_drawSpriteMasked_asm
	ret

	number_two:
	ld a, vill_hit_player(ix)
	cp #0
	jr z, no_hay_golpe_2

	ld a, #0
	ld vill_hit_player(ix), a
	ld hl, #_sprite_villain_pink_hit
	call cpct_drawSpriteMasked_asm
	ret

	no_hay_golpe_2:
	ld hl, #_sprite_villain_pink
	call cpct_drawSpriteMasked_asm
	ret

	number_one:
	ld a, villain_shot(ix)
	cp #0
	jr z, no_hay_golpe_1
	call bulletVillain_getPtrIX
	ld a, 5(ix)
	cp #1
	jr z, no_hay_golpe_1

	ld hl, #_sprite_villain_blue_hit
	call cpct_drawSpriteMasked_asm
	ret

	no_hay_golpe_1:
	ld hl, #_sprite_villain_blue
	call cpct_drawSpriteMasked_asm

	ret

	number_zero:
	ld a, vill_hit_player(ix)
	cp #0
	jr z, no_hay_golpe_0

	ld a, #0
	ld vill_hit_player(ix), a
	ld hl, #_sprite_villain_green_hit
	call cpct_drawSpriteMasked_asm
	ret

	no_hay_golpe_0:
	ld hl, #_sprite_villain_green
	call cpct_drawSpriteMasked_asm

	ret

	eraseVillain:
	ld a, vill_x(ix)
	ld b, #2
	ld c, #0
	bucle:
	inc c
	sub b
	


	jp m, divide_y
	jr z, divide_y

	jr bucle

	divide_y:

	dec c

	ld d, #4
	ld a, vill_y(ix)

	cp #124

	jp p, asignar
	jr z, asignar

	jr here

	asignar:
	ld b, #31
	ld e, #124
	sub e
	jr bu

	here:
	ld b, #0

	bu:
	inc b
	sub d
	

	jp m, redibuja
	jr z, redibuja

	jr bu

	redibuja:
	dec b
	ld a, vill_number(ix)
	cp #4
	jr z,vll_004
	jr saltico
	vll_004:
	dec b
	;;llamar a redibujar mapa
	saltico:
	call getStage
	cp #1
	jr z, stage_uno
	cp #2
	jr z, stage_dos
	cp #3
	jr z, stage_tres
	cp #4
	jr z, stage_cuatro

	ld hl, #_stage_5
	push hl
	jr saltar

	stage_cuatro:
	ld hl, #_stage_4
	push hl
	jr saltar

	ld hl, #_stage_4
	push hl
	jr saltar

	stage_tres:
	ld hl, #_stage_3
	push hl
	jr saltar

	stage_dos:
	ld hl, #_stage_2
	push hl
	jr saltar

	stage_uno:
	ld hl, #_stage_1
	push hl

	saltar:

	call map_getVideoPtr
	push hl

	ld a, vill_number(ix)
	cp #4
	jr z,vll_4 
	ld d, #5
	ld e, #4
	jr go_on
	vll_4:
	ld d, #7
	ld e, #6
	go_on:

	ld a, #40

	call cpct_etm_drawTileBox2x4_asm

	ret